package com.megabras.bluelogg.DT70KV;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.megabras.bluelogg.R;

import java.util.ArrayList;
import java.util.List;

public class TableFilesAdapter extends BaseAdapter
{
    private LayoutInflater
            inflater;

    private List<FileDetails>
            fileDetailsList;

    private Context
            context;

    public TableFilesAdapter(Context context)
    {
        fileDetailsList = new ArrayList<>();
        inflater        = LayoutInflater.from(context);
        this.context    = context;
    }

    static class ViewHolder
    {
        TextView
                ui_txw_glove_serial,
                ui_txw_test_number,
                ui_txw_date;
    }

    public int getCount()
    {
        return fileDetailsList.size();
    }

    public FileDetails getItem(int position)
    {
        return fileDetailsList.get(position);
    }

    @Override
    public long getItemId(int position)
    {
        return 0;
    }

    public void add(String glove, int test, String date)
    {
        FileDetails f = new FileDetails();
        f.GLOVE_SERIAL = glove;
        f.TEST_NUMBER  = test;
        f.DATE         = date;
        fileDetailsList.add( f );
    }

    public void remove(int position)
    {
        fileDetailsList.remove(position);
    }

    public void clear()
    {
        fileDetailsList.clear();
    }

    public void repaint()
    {
        notifyDataSetChanged();
    }

    private TextView getTXW(int id, View v)
    {
        return ( (TextView)v.findViewById(id) );
    }

    public View getView(int position, View vi, ViewGroup parent)
    {
        if ( vi == null )
        {
            ViewHolder h          = new ViewHolder();
            vi                    = inflater.inflate( R.layout.dt70kv_table_saved_files, parent, false );
            h.ui_txw_glove_serial = getTXW(R.id.ui_txw_glove_serial , vi);
            h.ui_txw_test_number  = getTXW(R.id.ui_txw_test_number  , vi);
            h.ui_txw_date         = getTXW(R.id.ui_txw_date         , vi);
            vi.setTag(h);
        }

        String serial = fileDetailsList.get(position).TEST_NUMBER + "";
        ViewHolder h  = (ViewHolder) vi.getTag();
        h.ui_txw_glove_serial.setText( fileDetailsList.get(position).GLOVE_SERIAL );

        if ( fileDetailsList.get(position).TEST_NUMBER > 0 )
        {
            h.ui_txw_test_number.setText( serial                             );
            h.ui_txw_date       .setText( fileDetailsList.get(position).DATE );
        }
        else
        {
            h.ui_txw_test_number.setText( "" );
            h.ui_txw_date       .setText( "" );
        }

        return vi;
    }
}

