package com.megabras.bluelogg.MDXXKVR;

import android.annotation.SuppressLint;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.megabras.bluelogg.extended.FileDetails;
import com.megabras.bluelogg.R;

import java.util.ArrayList;
import java.util.List;

public class TableFilesAdapter extends BaseAdapter
{
    private LayoutInflater
            inflater;

    private List<FileDetails>
            fileDetailsList;

    private String
            openedRecordId = "";

    TableFilesAdapter( Context context )
    {
        fileDetailsList = new ArrayList<>();
        inflater        = LayoutInflater.from( context );
    }

    static class ViewHolder
    {
        TextView
                ui_txw_label_id,
                ui_txw_record_id,
                ui_txw_record_name,
                ui_txw_last_change;

        LinearLayout
                ui_lyt_opened;
    }

    public int getCount()
    {
        return fileDetailsList.size();
    }

    public FileDetails getItem( int position )
    {
        return fileDetailsList.get( position );
    }

    @Override
    public long getItemId( int position )
    {
        return 0;
    }

    public void add( List<FileDetails> fileDetails )
    {
        //fileDetailsList.clear();
        fileDetailsList = fileDetails;
        notifyDataSetChanged();
    }

    public void add( FileDetails f )
    {
        fileDetailsList.add( f );
    }

    public List<FileDetails> getAll()
    {
        return fileDetailsList;
    }

    int setOpenedRecordId( String recId )
    {
        openedRecordId = recId;
        for ( int i = 0; i < fileDetailsList.size(); i++ )
        {
            if ( fileDetailsList.get( i ).INDEX.equals( openedRecordId ) )
            {
                return i;
            }
        }
        return -1;
    }

    public boolean isOpended( int position )
    {
        try
        {
            return fileDetailsList.get( position ).INDEX.equals( openedRecordId );
        }
        catch ( Exception e )
        {
            return false;
        }
    }

    public void remove( int position )
    {
        fileDetailsList.remove( position );
    }

    public void clear()
    {
        fileDetailsList.clear();
    }

    public void repaint()
    {
        notifyDataSetChanged();
    }

    private TextView getTXW( int id, View v )
    {
        return ((TextView) v.findViewById( id ));
    }

    @SuppressLint("SetTextI18n")
    public View getView( int position, View vi, ViewGroup parent )
    {
        if ( vi == null )
        {
            ViewHolder h = new ViewHolder();
            vi                   = inflater.inflate( R.layout.mpkxx5r_table_saved_files, parent, false );
            h.ui_txw_label_id    = getTXW( R.id.ui_txw_label_id   , vi );
            h.ui_txw_record_id   = getTXW( R.id.ui_txw_record_id  , vi );
            h.ui_txw_record_name = getTXW( R.id.ui_txw_record_name, vi );
            h.ui_txw_last_change = getTXW( R.id.ui_txw_last_change, vi );
            h.ui_lyt_opened      = vi.findViewById( R.id.ui_lyt_opened );
            vi.setTag( h );
        }

        ViewHolder h = (ViewHolder) vi.getTag();
        h.ui_txw_label_id.setText( R.string.test_number );
        h.ui_txw_record_id.setText( fileDetailsList.get( position ).INDEX );
        h.ui_txw_record_name.setText( fileDetailsList.get( position ).MODEL + " " + fileDetailsList.get( position ).SERIAL );
        h.ui_txw_last_change.setText( fileDetailsList.get( position ).DATE );
        if ( openedRecordId.equals( fileDetailsList.get( position ).INDEX ) )
        {
            h.ui_lyt_opened.setVisibility( View.VISIBLE );
        }
        else
        {
            h.ui_lyt_opened.setVisibility( View.GONE );
        }

        return vi;
    }
}

