package com.megabras.bluelogg;

import java.io.File;
import java.io.IOException;
import java.util.ArrayList;
import java.util.List;

import android.media.AudioManager;
import android.media.MediaPlayer;
import android.media.MediaRecorder;
import android.media.MediaRecorder.OnInfoListener;
//import android.support.v4.app.ActivityCompat;
import android.util.Log;

public class RecordAudio
{
	private static final String
            LOG_TAG = "AudioRecordTest";
	private String
            mFileName = "";
	private MediaRecorder
            mRecorder = null;
	private MediaPlayer
            mPlayer = null;
	private final int
            maxAudioDuration = 60000;
	private RecordEventListener
            recordEvent;

	public void setRecordEventListener(RecordEventListener recordEvent)
    {
		this.recordEvent = recordEvent;
	}

	public boolean fileExists()
    {
		File file = new File(mFileName);
		return file.exists();
	}
	
	public long fileGetSize()
    {
		File file = new File(mFileName);		
		return file.length();
	}

	public List<String> getAudioList(File dirsite)
    {
		List<String> list = new ArrayList<String>();		
		if (dirsite.isDirectory()){
			for (File child : dirsite.listFiles()){
				if(child.getName().contains(".3gp")){
					list.add(child.getName());
				}				
	        }
		}
		return list;
	}

	public void setAudioFile(File folder, String object, String testNumber)
    {
		String obj = MUtils.removeSpecialChars(object);
		String audioFile = "object_" + obj + "_test-" + testNumber + "_annotation.3gp";
		File location = new File(folder, audioFile);
		mFileName = location.toString();		
	}

    public void setAudioFile(File file){
        mFileName = file.toString();
    }

	public void setAudioFile(String filePath){		
		mFileName = filePath;		
	}
		
	public String getOutputFile(){
		return this.mFileName;
	}

	public void startRecording() {
//        if (ActivityCompat.checkSelfPermission(ac, android.Manifest.permission.ACCESS_FINE_LOCATION) != PackageManager.PERMISSION_GRANTED && ActivityCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION) != PackageManager.PERMISSION_GRANTED) {
//            return;
//        }
        mRecorder = new MediaRecorder();
        mRecorder.setAudioSource(MediaRecorder.AudioSource.MIC);
        mRecorder.setOutputFormat(MediaRecorder.OutputFormat.THREE_GPP);
        mRecorder.setOutputFile(mFileName);
        mRecorder.setMaxDuration(maxAudioDuration);
        
        mRecorder.setOnInfoListener(new OnInfoListener() {            
            public void onInfo(MediaRecorder mr, int what, int extra) {                     
            	stopRecording();
            }
        });
        
        mRecorder.setAudioEncoder(MediaRecorder.AudioEncoder.AMR_NB);
        
        try {
            mRecorder.prepare();
        } catch (IOException e) {
            Log.e(LOG_TAG, "prepare() failed");
        }
        recordEvent.recording(true);
        mRecorder.start();
    }

    public void stopRecording() {
    	if(mRecorder!=null){
    		mRecorder.stop();
            mRecorder.release();
            mRecorder = null;
            recordEvent.recording(false);
    	}        
    }

    public void startPlaying() {
        mPlayer = new MediaPlayer();
        try {
            mPlayer.setDataSource(mFileName);
            //mPlayer.setAudioStreamType(AudioManager.STREAM_MUSIC);
            mPlayer.prepare();
            mPlayer.setOnCompletionListener(new MediaPlayer.OnCompletionListener() {                
                public void onCompletion(MediaPlayer mp) {            	
                	recordEvent.playing(false);               	
                }
            });
            recordEvent.playing(true);
            mPlayer.start();
        } catch (IOException e) {
            Log.e(LOG_TAG, "prepare() failed");
        }
    }

    public int getAudioLenght() {        
        try {
        	mPlayer = new MediaPlayer();
        	int duration;
            mPlayer.setDataSource(mFileName);
            mPlayer.prepare();
            duration = mPlayer.getDuration();        
            mPlayer.release();
            mPlayer = null;
            return duration;
        } catch (IOException e) {
            Log.e(LOG_TAG, "prepare() failed");
            return 0;
        }
    }

    public void stopPlaying() {
    	if(mPlayer!=null){
    		mPlayer.release();
            mPlayer = null;
            recordEvent.playing(false);
    	}        
    }
	
}
