package com.megabras.bluelogg.em4058;

import android.Manifest;
import android.annotation.SuppressLint;
import android.app.Dialog;
import android.bluetooth.BluetoothAdapter;
import android.bluetooth.BluetoothDevice;
import android.content.Context;
import android.content.DialogInterface.OnDismissListener;
import android.content.Intent;
import android.content.SharedPreferences;
import android.content.pm.PackageManager;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.graphics.drawable.LayerDrawable;
import android.media.ThumbnailUtils;
import android.os.Bundle;
import android.os.Environment;
import android.os.Handler;
import android.os.Message;
import android.os.SystemClock;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuInflater;
import android.view.MenuItem;
import android.view.View;
import android.view.Window;
import android.view.WindowManager.LayoutParams;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.Chronometer;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.TabHost;
import android.widget.TabHost.TabSpec;
import android.widget.TextView;

import com.megabras.bluelogg.Command;
import com.megabras.bluelogg.MUtils;
import com.megabras.bluelogg.R;
import com.megabras.bluelogg.RecordAudio;
import com.megabras.bluelogg.RecordEventListener;
import com.megabras.bluelogg.bluetooth.EnableBluetooth;
import com.megabras.bluelogg.extended.GPS;
import com.megabras.bluelogg.extended.GoogleMaps;
import com.megabras.bluelogg.extended.MDialog;
import com.megabras.bluelogg.extended.MapData;
import com.megabras.bluelogg.extended.Picture;
import com.megabras.bluelogg.tm25r.ListSites;
import com.megabras.bluelogg.tm25r.ListSitesDetails;

import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.lang.ref.WeakReference;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Collections;
import java.util.Date;
import java.util.LinkedList;
import java.util.List;
import java.util.Locale;
import java.util.Objects;
import java.util.Queue;
import java.util.TimeZone;

import androidx.annotation.NonNull;
import androidx.appcompat.app.AppCompatActivity;
import androidx.core.app.ActivityCompat;
import androidx.core.content.ContextCompat;
import androidx.core.content.res.ResourcesCompat;

public class EM4058 extends AppCompatActivity implements GPS.GpsInterface, RecordEventListener, Picture.PictureInterface
{
	public static final int COLOR_BLACK  = R.drawable.chamfer_small_black;
	public static final int COLOR_YELLOW = R.drawable.chamfer_small_yellow;
	public static final int COLOR_GREEN  = R.drawable.chamfer_small_green;
	public static final int COLOR_RED    = R.drawable.chamfer_small_red;
	public static final String RHO_SYMBOL = "\u03C1";
	@SuppressWarnings("FieldCanBeLocal")
	private final String TAG = "EM4058";
	private Context context = this;
	private Menu menu;
	private String rx = "";
	private Dialog dlgDetails;
	private Dialog dlgAudio;
	private Dialog dlgProgress;
	private String model;
	private String mac;
	private String serial;
	private boolean isTestRunning = false;
	private boolean testStopped = false;
	private static int cmdType = 0;
	private Handler h2;
	private Runnable rxTimeOut;
	private Runnable checkConnection;
	private SharedPreferences.Editor editor;
	private boolean tryConnOnce = true;
	private boolean autoConn;
	private final int PING_TIME = 500;
	private int rxTries = 0;
	private int timeoutCount = 0;
	private String selOp = "";
	private String selSite = "";
	private int selSiteIndex;
	private int selFileIndex = -1;
	private String selFileName = "";
	private String selObj = "";
	private String selTest = "";
	private int indexOfSelObject = -1;
	private int indexOfSelTest = -1;
	private RecordAudio audio;
	private String[] gps;
	private android.media.MediaPlayer shutter;
	private EM4058test test;
	private Runnable runFIFO;
	private Queue<Command> FIFO;
	private final int FIFO_TIME = 100;
	private boolean idle = true;
	private Picture picture;
	private EM4058BluetoothThread bluetoothThread = null;
	private boolean isDisconnectedByUser = false;
	private EM4058TableBaseAdapter adapter;

	private GPS
			mGPS;

	private GoogleMaps
			gMap;

	public static boolean
			permissionToRecordAccepted  = false,
			permissionToPictureAccepted = false,
			permissionToGPSAccepted     = false,
			permissionToMemoryAccepted  = false;

	public static String []
			permissionsMemory   = {android.Manifest.permission.READ_EXTERNAL_STORAGE, android.Manifest.permission.WRITE_EXTERNAL_STORAGE},
			permissionsAudio    = {android.Manifest.permission.READ_EXTERNAL_STORAGE, android.Manifest.permission.WRITE_EXTERNAL_STORAGE, android.Manifest.permission.RECORD_AUDIO},
			permissionsPicture  = {android.Manifest.permission.READ_EXTERNAL_STORAGE, android.Manifest.permission.WRITE_EXTERNAL_STORAGE, android.Manifest.permission.CAMERA},
			permissionsGPS      = {android.Manifest.permission.ACCESS_COARSE_LOCATION, android.Manifest.permission.ACCESS_FINE_LOCATION};

	public static final int
			REQUEST_RECORD_AUDIO_PERMISSION  = 200,
			REQUEST_PICTURE_PERMISSION       = 201,
			REQUEST_GPS_PERMISSION           = 202,
			REQUEST_MEMORY_PERMISSION        = 203,
			REQUEST_MEMORY_REPORT_PERMISSION = 204,
			REQUEST_MEMORY_MAP_PERMISSION    = 205;

	private void checkPermissions(){
		if (ContextCompat.checkSelfPermission(this, android.Manifest.permission.READ_EXTERNAL_STORAGE)== PackageManager.PERMISSION_GRANTED &&
				ContextCompat.checkSelfPermission(this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE)==PackageManager.PERMISSION_GRANTED) {
			permissionToMemoryAccepted = true;
		}
		if (ContextCompat.checkSelfPermission(this, android.Manifest.permission.READ_EXTERNAL_STORAGE)==PackageManager.PERMISSION_GRANTED &&
				ContextCompat.checkSelfPermission(this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE)==PackageManager.PERMISSION_GRANTED &&
				ContextCompat.checkSelfPermission(this, android.Manifest.permission.CAMERA)==PackageManager.PERMISSION_GRANTED) {
			permissionToPictureAccepted = true;
		}
		if (ContextCompat.checkSelfPermission(this, android.Manifest.permission.READ_EXTERNAL_STORAGE)==PackageManager.PERMISSION_GRANTED &&
				ContextCompat.checkSelfPermission(this, android.Manifest.permission.WRITE_EXTERNAL_STORAGE)==PackageManager.PERMISSION_GRANTED &&
				ContextCompat.checkSelfPermission(this, android.Manifest.permission.RECORD_AUDIO)==PackageManager.PERMISSION_GRANTED) {
			permissionToRecordAccepted = true;
		}
		if (ContextCompat.checkSelfPermission(this, android.Manifest.permission.ACCESS_COARSE_LOCATION)==PackageManager.PERMISSION_GRANTED &&
				ContextCompat.checkSelfPermission(this, Manifest.permission.ACCESS_FINE_LOCATION)==PackageManager.PERMISSION_GRANTED) {
			permissionToGPSAccepted = true;
		}
	}

	@Override
	public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
		super.onRequestPermissionsResult(requestCode, permissions, grantResults);
		switch (requestCode){
			case REQUEST_RECORD_AUDIO_PERMISSION:
				permissionToRecordAccepted  = (grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED && grantResults[2] == PackageManager.PERMISSION_GRANTED);
				if (permissionToRecordAccepted)
					permissionCallback(requestCode);
				break;
			case REQUEST_PICTURE_PERMISSION:
				permissionToPictureAccepted  = (grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED && grantResults[2] == PackageManager.PERMISSION_GRANTED);
				if (permissionToPictureAccepted)
					permissionCallback(requestCode);
				break;
			case REQUEST_GPS_PERMISSION:
				permissionToGPSAccepted = (grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED);
				if (permissionToGPSAccepted)
					permissionCallback(requestCode);
				break;
			case REQUEST_MEMORY_PERMISSION:
				permissionToMemoryAccepted = (grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED);
				if (permissionToMemoryAccepted)
					permissionCallback(requestCode);
				break;
			case REQUEST_MEMORY_REPORT_PERMISSION:
				permissionToMemoryAccepted = (grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED);
				if (permissionToMemoryAccepted)
					permissionCallback(requestCode);
				break;
			case REQUEST_MEMORY_MAP_PERMISSION:
				permissionToMemoryAccepted = (grantResults[0] == PackageManager.PERMISSION_GRANTED && grantResults[1] == PackageManager.PERMISSION_GRANTED);
				if (permissionToMemoryAccepted)
					permissionCallback(requestCode);
				break;
		}
	}

	public void requestPermission(int permission)
	{
		String[] list = null;
		switch (permission)
		{
			case REQUEST_RECORD_AUDIO_PERMISSION:
				list = permissionsAudio;
				break;
			case REQUEST_PICTURE_PERMISSION:
				list = permissionsPicture;
				break;
			case REQUEST_GPS_PERMISSION:
				list = permissionsGPS;
				break;
			case REQUEST_MEMORY_PERMISSION:
				list = permissionsMemory;
				break;
			case REQUEST_MEMORY_REPORT_PERMISSION:
				list = permissionsMemory;
				break;
			case REQUEST_MEMORY_MAP_PERMISSION:
				list = permissionsMemory;
				break;
		}
		if (list!=null)
			ActivityCompat.requestPermissions(this, list, permission);
	}

	public void permissionCallback(int permission)
	{
		switch (permission)
		{
			case REQUEST_RECORD_AUDIO_PERMISSION:
				audio();
				break;
			case REQUEST_PICTURE_PERMISSION:
				picture();
				break;
			case REQUEST_GPS_PERMISSION:
				gps();
				break;
			case REQUEST_MEMORY_REPORT_PERMISSION:
				break;
			case REQUEST_MEMORY_PERMISSION:
				test.createFolder();
				test.createCompanyFile();
				test.createSitesFile();
				createManagerDialog(0);
				break;
			case REQUEST_MEMORY_MAP_PERMISSION:
				map();
				break;
		}
	}


	@Override
	public void onCreate(Bundle savedInstanceState)
	{
		super.onCreate(savedInstanceState);
		setContentView(R.layout.em4058);

		Command.enableFrame(true);
		keepTheScreenOn(true);

		checkPermissions();

		ListView list = new ListView(this);
		list.setScrollbarFadingEnabled( false );
		list.setTranscriptMode(ListView.TRANSCRIPT_MODE_ALWAYS_SCROLL);
		list.setStackFromBottom(true);
		list.setSelector(android.R.color.transparent);
		((LinearLayout)findViewById(R.id.container_results)).addView(list);
		adapter = new EM4058TableBaseAdapter(this);
		list.setAdapter( adapter );

		picture = Picture.getInstance();
		picture.initialize(this, this);
		mGPS = new GPS(this);

		gMap = new GoogleMaps( this );

		setTextTW( R.id.lb_model, "" );
		setTextTW( R.id.lb_user_message, "" );
		setTextTW( R.id.lb_resistance, "- - -" );
		setTextTW( R.id.lb_test_number, "- - -" );
		setTextTW( R.id.lb_distance, "" );
		setTextTW( R.id.lb_frequency, "" );
		setTextTW( R.id.lb_resistance_270Hz, "" );
		setTextTW( R.id.lb_resistance_570Hz, "" );
		setTextTW( R.id.lb_resistance_870Hz, "" );
		setTextTW( R.id.lb_resistance_1170Hz, "" );
		setTextTW( R.id.lb_resistance_1470Hz, "" );

		loadExtras();
		loadSharedPreferences();
		enableButtonImage(R.id.btn_objects, false);
		enableButtonImage(R.id.btn_gps, false);
		enableButtonImage(R.id.btn_picture, false);
		enableButtonImage(R.id.btn_sound, false);
		enableButtonImage(R.id.btn_map, false);
		enableKeyboard(false);

		FIFO = new LinkedList<>();

		h2 = new Handler();

		test = new EM4058test(this, model);
		test.setEquipmentModel( MUtils.checkNull(model) , MUtils.checkNull(serial) );
		if(permissionToMemoryAccepted){
			test.createFolder();
			test.createCompanyFile();
			test.createSitesFile();
		}

		audio = new RecordAudio();
		audio.setRecordEventListener(this);

		rxTimeOut = () ->
		{
			timeoutCount = 0;
			if(MUtils.checkSum(rx))
			{
				try
				{
					rxTries = -1;
					processProtocol(rx);
				}
				catch (Exception e)
				{
					cmdType = 99;
					rx = e.toString();
					processProtocol(rx);
				}
			}
			if(rxTries > 5){
				cmdType = 99;
				processProtocol(rx);
				rxTries = -1;
			}
			rxTries++;
		};

		checkConnection = new Runnable()
		{
			public void run()
			{
				int maxPingTimes = 4;
				if ( timeoutCount > 1 && timeoutCount < maxPingTimes )
				{
					idle = true;
					if ( FIFO.isEmpty() )
					{
						FIFO.add( Command.EM4058.SHORT_STATUS() );
					}
				}
				if ( timeoutCount >= maxPingTimes )
				{
					disconnect();
					isConnected( false );
					timeoutCount = 0;
					return;
				}
				timeoutCount++;
				h2.postDelayed( this, PING_TIME );
			}
		};

		runFIFO = new Runnable()
		{
			public void run()
			{
				String cmd;
				if ( idle && FIFO != null && !FIFO.isEmpty() )
				{
					idle = false;
					if ( !testStopped )
					{
						Command c = FIFO.peek();
						cmdType = Objects.requireNonNull( c ).getType();
						cmd = c.getCommand();
					}
					else
					{
						FIFO.clear();
						FIFO.add( Command.EM4058.STOP() );
						cmdType = Command.EM4058.STOP().getType();
						cmd = Command.EM4058.STOP().getCommand();
					}
					statusBlink();
					cmd = Command.SF + cmd + Command.EF;

					if ( FIFO.peek() != null && Objects.requireNonNull( FIFO.peek() ).getType() != Command.EM4058.SHORT_STATUS().getType() )
					{
						timeoutCount = 0;
					}
					rx = "";

					bluetoothThread.write( cmd.getBytes() );
				}
				h2.postDelayed( this, FIFO_TIME );
			}
		};

		try
		{
			if ( getSupportActionBar() != null )
			{
				getSupportActionBar().setDisplayShowHomeEnabled( true );
				getSupportActionBar().setIcon( R.drawable.brand_small );
				getSupportActionBar().setDisplayShowTitleEnabled( false );
				getSupportActionBar().setElevation( 0 );
			}
		}
		catch ( Exception ignored )
		{
		}
	}

	@Override
	public boolean onCreateOptionsMenu( Menu menu )
	{
		MenuInflater inflater = getMenuInflater();
		inflater.inflate( R.menu.main_menu, menu );
		this.menu = menu;
		menu.findItem( R.id.changedevice ).setVisible( true );
		changeAlpha( 1, false );
		changeAlpha( 2, false );
		changeAlpha( 3, false );
		isConnected( false );
		enableManagerBar( !autoConn );
		return true;
	}

	@Override
	public boolean onOptionsItemSelected( @NonNull MenuItem item )
	{
		switch ( item.getItemId() )
		{
			case R.id.connect:
				this.connecting();
				return true;
			case R.id.changedevice:
				this.selectAnotherDevice();
				return true;
			case R.id.disconnect:
				isDisconnectedByUser = true;
				this.disconnect();
				isConnected( false );
				return true;
			case R.id.options:
				createOptionsDialog();
				return true;
			default:
				return super.onOptionsItemSelected( item );
		}
	}

	@Override
	protected void onStart()
	{
		super.onStart();
		if ( tryConnOnce && autoConn )
		{
			tryConnOnce = false;
			this.connecting();
		}
		try
		{
			android.content.res.AssetFileDescriptor afd = getAssets().openFd( "shutter.mp3" );
			shutter = new android.media.MediaPlayer();
			shutter.setDataSource( afd.getFileDescriptor(), afd.getStartOffset(), afd.getLength() );
			shutter.prepare();
		}
		catch ( IOException e )
		{
			e.printStackTrace();
		}
	}

	@Override
	protected void onDestroy() {
		super.onDestroy();
		this.closeApp();
	}

	@Override
	public void onBackPressed()
	{
		if ( bluetoothThread != null && bluetoothThread.getState() == EM4058BluetoothThread.STATE_CONNECTING )
		{
			return;
		}
		MDialog.ExitApplication( this ).show();
	}

	private void loadExtras(){
		Bundle extras = getIntent().getExtras();
		if (extras != null) {
			mac    = MUtils.checkNull(extras.getString("MAC"));
			serial = MUtils.checkNull(extras.getString("SERIAL"));
			model  = MUtils.checkNull(extras.getString("MODEL"));
		}
		((TextView) findViewById(R.id.lb_model)).setText(model + " " + serial);
	}

	@SuppressLint("CommitPrefEdits")
	private void loadSharedPreferences(){
		SharedPreferences sharedPref = this.getSharedPreferences("BLUELOGG",Context.MODE_PRIVATE);
		editor = sharedPref.edit();
		autoConn = sharedPref.getBoolean("autoConn", true);
	}

	private void changeAlpha(int led, boolean show) {
		ImageView img = findViewById(R.id.status_led);
		LayerDrawable layer = (LayerDrawable) img.getDrawable();
		if (show) {
			layer.getDrawable(led).setAlpha(255);
		} else {
			layer.getDrawable(led).setAlpha(0);
		}
	}

	private void statusBlink()
	{
		changeAlpha(3, true);
		h2.postDelayed(() -> changeAlpha(3, false), 100);
	}

	private void keepTheScreenOn(boolean keep)
	{
		if (keep) {
			getWindow().addFlags(LayoutParams.FLAG_KEEP_SCREEN_ON);
		} else {
			getWindow().clearFlags(LayoutParams.FLAG_KEEP_SCREEN_ON);
		}
	}

	private void createOptionsDialog()
	{
		final Dialog dialog = new Dialog( this );
		dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dialog.setContentView( R.layout.dialog_options );
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}
		((TextView) dialog.findViewById( R.id.dlg_title )).setText( R.string.options );
		((ImageView) dialog.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_options_states );

		dialog.findViewById(R.id.dialog_options_container_highcontrast).setVisibility(View.GONE);
		dialog.findViewById(R.id.dialog_options_container_gps_timeout).setVisibility(View.GONE);

		Switch autoCon = dialog.findViewById( R.id.switch_connection );
		autoCon.setChecked( autoConn );
		autoCon.setOnCheckedChangeListener( ( buttonView, isChecked ) ->
		{
			autoConn = isChecked;
			editor.putBoolean( "autoConn", autoConn );
			editor.commit();
		} );

		final Button switchDev = dialog.findViewById( R.id.btn_switch );
		switchDev.setOnClickListener( v ->
		{
			createEquipmentDetailsDialog();
			dialog.dismiss();
		} );

		dialog.findViewById( R.id.btn_about ).setOnClickListener( v ->
		{
			createAboutDialog();
			dialog.dismiss();
		} );

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( v -> dialog.dismiss() );
		dialog.findViewById( R.id.btn_cancel ).setOnClickListener( v -> dialog.dismiss() );

		dialog.setOnShowListener( dialog1 ->
		{
			if ( bluetoothThread != null && bluetoothThread.getState() == EM4058BluetoothThread.STATE_CONNECTED )
			{
				switchDev.setEnabled( true );
			}
			else
			{
				switchDev.setEnabled( false );
			}
		} );

		dialog.show();
	}

	private void createEquipmentDetailsDialog()
	{
		dlgDetails = new Dialog( this );
		dlgDetails.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dlgDetails.setContentView( R.layout.dialog_equipment_details );
		if ( dlgDetails.getWindow() != null )
		{
			dlgDetails.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}
		((TextView) dlgDetails.findViewById( R.id.dlg_title )).setText( R.string.equipment_details );
		((ImageView) dlgDetails.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_device_generic );

		final TextView lblModel = dlgDetails.findViewById( R.id.lbl_model );
		final TextView lblSerial = dlgDetails.findViewById( R.id.lbl_serial );
		final TextView lblDate = dlgDetails.findViewById( R.id.lbl_date );
		final TextView lblBattery = dlgDetails.findViewById( R.id.lbl_battery );
		final TextView lblMem = dlgDetails.findViewById( R.id.lbl_mem );

		lblModel.setText( model );
		lblSerial.setText( serial );

		dlgDetails.findViewById( R.id.btn_close_dlg ).setOnClickListener( v -> dlgDetails.dismiss() );

		dlgDetails.findViewById( R.id.btn_refresh ).setOnClickListener(v ->
		{
			lblDate.setText(R.string.wait);
			lblBattery.setText(R.string.wait);
			lblMem.setText(R.string.wait);
			FIFO.add( Command.EM4058.SHORT_STATUS() );
			FIFO.add( Command.GET_DATE() );
			FIFO.add( Command.FREE_MEMORY() );
		});

		dlgDetails.findViewById( R.id.btn_date ).setOnClickListener( v ->
		{
			lblDate.setText(R.string.wait);
			FIFO.add( Command.SET_DATE() );
			FIFO.add( Command.GET_DATE() );
		});

		dlgDetails.findViewById( R.id.btn_erase ).setOnClickListener( v ->
		{
			final Dialog dialog = new Dialog(context);
			dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
			dialog.setCanceledOnTouchOutside(false);
			dialog.setContentView(R.layout.dialog_yes_no);
			if ( dialog.getWindow() != null )
			{
				dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
			}
			((TextView) dialog.findViewById(R.id.dlg_title)).setText(R.string.erase_memory);
			((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_warning);

			final TextView message = dialog.findViewById(R.id.message);
			message.setText(R.string.erase_memory_confirm);

			dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener(v1 -> dialog.dismiss());
			dialog.findViewById( R.id.btn_no ).setOnClickListener(v1 -> dialog.dismiss());

			final Button btnYes = dialog.findViewById(R.id.btn_yes);
			btnYes.setOnClickListener(v12 -> {
				lblMem.setText(R.string.wait);
				FIFO.add( Command.ERASE_MEMORY() );
				FIFO.add( Command.FREE_MEMORY() );
				dialog.dismiss();
			});

			dialog.show();
		});

		dlgDetails.setOnShowListener( dialog ->
		{
			FIFO.add( Command.EM4058.SHORT_STATUS() );
			FIFO.add( Command.GET_DATE() );
			FIFO.add( Command.FREE_MEMORY() );
		} );

		dlgDetails.show();
	}

	private void createSettingsDialog( final boolean isResistance )
	{
		final Dialog dialog = new Dialog( this );
		dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dialog.setContentView( R.layout.dialog_empty );
		dialog.setCanceledOnTouchOutside( false );
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().getAttributes().width = LayoutParams.WRAP_CONTENT;
			dialog.getWindow().getAttributes().height = LayoutParams.WRAP_CONTENT;
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}

		((ImageView) dialog.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_options_small );

		ArrayList<String> spinnerArray = new ArrayList<>();

		if ( isResistance )
		{
			((TextView) dialog.findViewById( R.id.dlg_title )).setText( R.string.earth_resistance );
			((TextView) dialog.findViewById( R.id.txw_label )).setText( R.string.frequency );
			spinnerArray.addAll( Arrays.asList( Command.EM4058.getFrequencyList() ) );
		}
		else
		{
			((TextView) dialog.findViewById( R.id.dlg_title )).setText( R.string.soil_resistivity );
			((TextView) dialog.findViewById( R.id.txw_label )).setText( R.string.distance );
			spinnerArray.add( "1 m" );
			spinnerArray.add( "2 m" );
			spinnerArray.add( "3 m" );
			spinnerArray.add( "4 m" );
			spinnerArray.add( "5 m" );
			spinnerArray.add( "6 m" );
			spinnerArray.add( "7 m" );
			spinnerArray.add( "8 m" );
			spinnerArray.add( "9 m" );
			spinnerArray.add( "10 m" );
			spinnerArray.add( "11 m" );
			spinnerArray.add( "12 m" );
			spinnerArray.add( "13 m" );
			spinnerArray.add( "14 m" );
			spinnerArray.add( "15 m" );
			spinnerArray.add( "16 m" );
			spinnerArray.add( "17 m" );
			spinnerArray.add( "18 m" );
			spinnerArray.add( "19 m" );
			spinnerArray.add( "20 m" );
			spinnerArray.add( "21 m" );
			spinnerArray.add( "22 m" );
			spinnerArray.add( "23 m" );
			spinnerArray.add( "24 m" );
			spinnerArray.add( "25 m" );
			spinnerArray.add( "26 m" );
			spinnerArray.add( "27 m" );
			spinnerArray.add( "28 m" );
			spinnerArray.add( "29 m" );
			spinnerArray.add( "30 m" );
			spinnerArray.add( "31 m" );
			spinnerArray.add( "32 m" );
			spinnerArray.add( "33 m" );
			spinnerArray.add( "34 m" );
			spinnerArray.add( "35 m" );
			spinnerArray.add( "36 m" );
			spinnerArray.add( "37 m" );
			spinnerArray.add( "38 m" );
			spinnerArray.add( "39 m" );
			spinnerArray.add( "40 m" );
			spinnerArray.add( "41 m" );
			spinnerArray.add( "42 m" );
			spinnerArray.add( "43 m" );
			spinnerArray.add( "44 m" );
			spinnerArray.add( "45 m" );
			spinnerArray.add( "46 m" );
			spinnerArray.add( "47 m" );
			spinnerArray.add( "48 m" );
			spinnerArray.add( "49 m" );
			spinnerArray.add( "50 m" );
			spinnerArray.add( "Rx" );
		}

		final Spinner spinner = dialog.findViewById( R.id.spn_option );
		ArrayAdapter<String> spinnerArrayAdapter = new ArrayAdapter<>( this, android.R.layout.simple_spinner_dropdown_item, spinnerArray );
		spinner.setAdapter( spinnerArrayAdapter );

		Button saveButton = dialog.findViewById( R.id.bt_yes );
		saveButton.setText( R.string.save );
		saveButton.setOnClickListener( v ->
		{
			if ( isResistance )
			{
				int selectedIndex = spinner.getSelectedItemPosition();
				if ( selectedIndex == spinner.getCount() - 1 )
				{
					FIFO.add( Command.EM4058.WRITE_MODE( Command.EM4058.MODE_EARTH_RESISTANCE_SCAN, selectedIndex ) );
				}
				else
				{
					FIFO.add( Command.EM4058.WRITE_MODE( Command.EM4058.MODE_EARTH_RESISTANCE, selectedIndex ) );
				}
			}
			else
			{
				String selectedItem = spinner.getSelectedItem().toString();
				FIFO.add( Command.EM4058.WRITE_MODE( Command.EM4058.MODE_SOIL_RESISTIVITY, selectedItem ) );
			}
			messageBox( R.string.updating, COLOR_YELLOW, true );
			enableKeyboard( false );
			dialog.dismiss();
		} );

		Button cancelButton = dialog.findViewById(R.id.bt_no);
		cancelButton.setText(R.string.cancel);
		cancelButton.setOnClickListener( v -> dialog.dismiss() );
		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( v -> dialog.dismiss() );

		dialog.show();
	}

	private void createAboutDialog()
	{
		final Dialog dialog = new Dialog( this );
		dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dialog.setContentView( R.layout.dialog_about );
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().getAttributes().width = LayoutParams.WRAP_CONTENT;
			dialog.getWindow().getAttributes().height = LayoutParams.WRAP_CONTENT;
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}
		((TextView) dialog.findViewById( R.id.dlg_title )).setText( R.string.about );
		((ImageView) dialog.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_about );

		TextView appName = dialog.findViewById( R.id.lbl_appname );
		TextView appVersion = dialog.findViewById( R.id.lbl_version );
		TextView copyright = dialog.findViewById( R.id.lbl_copyright );

		try {
			long versionDate = getPackageManager().getPackageInfo(getPackageName(), 0).lastUpdateTime;
			SimpleDateFormat dateFormatter = new SimpleDateFormat("dd/MM/yyyy", Locale.getDefault());
			final TimeZone utc = TimeZone.getTimeZone("UTC");
			dateFormatter.setTimeZone(utc);

			appName.setText( getResources().getString(R.string.app_name) );

			appVersion.setText(
						getResources().getString(R.string.version) +
						": " + getPackageManager().getPackageInfo(getPackageName(), 0).versionName +
						"  " + getResources().getString(R.string.date) +
						" " + dateFormatter.format(versionDate)
					);

			copyright.setText(
					getResources().getString(R.string.copyright) +
					" " + getResources().getString(R.string.company) +
					". \r\n" + getResources().getString(R.string.rights)
					);

		} catch (Exception e) {
			e.printStackTrace();
		}

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( v -> dialog.dismiss() );
		dialog.findViewById( R.id.btn_cancel ).setOnClickListener( v -> dialog.dismiss() );

		dialog.show();
	}

	public void selectAnotherDevice(){
		Intent intent = new Intent(this, EnableBluetooth.class);
		startActivity(intent);
		this.closeApp();
	}

	private void enableManagerBar( boolean enable )
	{
		if ( menu != null )
		{
			for ( int i = 0; i < menu.size(); i++ )
			{
				menu.getItem( i ).setEnabled( enable );
			}
		}
		enableButtonImage( R.id.btn_manager, enable );
	}

	private void createSiteDetailsDialog(String selectedSite) {
		final Dialog dialog = new Dialog(this, R.style.MyThemeCompat);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_site);
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().getAttributes().width = LayoutParams.MATCH_PARENT;
			dialog.getWindow().getAttributes().height = LayoutParams.MATCH_PARENT;
		}
		((TextView) dialog.findViewById(R.id.dlg_title)).setText(R.string.site_edit);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_edit);

		final String selSite = selectedSite;
		final TextView required = dialog.findViewById(R.id.lbl_required);
		final TextView site = dialog.findViewById(R.id.txt_site);
		final TextView contact = dialog.findViewById(R.id.txt_site_contact);
		final TextView address = dialog.findViewById(R.id.txt_site_address);
		final TextView city = dialog.findViewById(R.id.txt_site_city);
		final TextView state = dialog.findViewById(R.id.txt_site_state);
		final TextView zipcode = dialog.findViewById(R.id.txt_site_zip);
		final TextView phone = dialog.findViewById(R.id.txt_site_phone);
		final TextView fax = dialog.findViewById(R.id.txt_site_fax);

		required.setVisibility(View.GONE);
		site.setKeyListener(null);
		site.setClickable(false);
		site.setEnabled(false);
		site.setTextColor(0x66FFFFFF);

		String[] details = test.getSiteDetails(selectedSite);
		site.setText	( selectedSite );
		contact.setText	( details[0] );
		address.setText	( details[1] );
		city.setText	( details[2] );
		state.setText	( details[3] );
		zipcode.setText	( details[4] );
		phone.setText	( details[5] );
		fax.setText		( details[6] );

		View.OnClickListener onClose = view ->
		{
			createManagerDialog(1);
			dialog.dismiss();
		};

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( onClose );
		dialog.findViewById( R.id.btn_site_cancel ).setOnClickListener( onClose );

		final Button save = dialog.findViewById(R.id.btn_site_save);
		save.setOnClickListener(v -> {
			if(!"".equals(site.getText().toString())){
				test.removeSite(selSite);
				test.addSite(
						site.getText().toString(),
						contact.getText().toString(),
						address.getText().toString(),
						city.getText().toString(),
						state.getText().toString(),
						zipcode.getText().toString(),
						phone.getText().toString(),
						fax.getText().toString()
				);
				createManagerDialog(1);
				dialog.dismiss();
			}
		});

		dialog.show();
	}

	private void createSiteAddDialog(final int option) {
		final Dialog dialog = new Dialog(this, R.style.MyThemeCompat);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_site);
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
			dialog.getWindow().getAttributes().width = LayoutParams.MATCH_PARENT;
			dialog.getWindow().getAttributes().height = LayoutParams.MATCH_PARENT;
		}
		((TextView) dialog.findViewById(R.id.dlg_title)).setText(R.string.site_new);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_new);

		final TextView site    = dialog.findViewById(R.id.txt_site);
		final TextView contact = dialog.findViewById(R.id.txt_site_contact);
		final TextView address = dialog.findViewById(R.id.txt_site_address);
		final TextView city    = dialog.findViewById(R.id.txt_site_city);
		final TextView state   = dialog.findViewById(R.id.txt_site_state);
		final TextView zipcode = dialog.findViewById(R.id.txt_site_zip);
		final TextView phone   = dialog.findViewById(R.id.txt_site_phone);
		final TextView fax     = dialog.findViewById(R.id.txt_site_fax);

		View.OnClickListener onClose = view ->
		{
			if ( option == 0 )
			{
				createManagerDialog( 1 );
			}
			dialog.dismiss();
		};

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( onClose );
		dialog.findViewById( R.id.btn_site_cancel ).setOnClickListener( onClose );

		final Button save = dialog.findViewById(R.id.btn_site_save);
		save.setOnClickListener(v -> {
			String siteName = site.getText().toString();
			if(!"".equals(siteName)){
				if(test.testsiteExists(siteName)){
					alert(R.string.site_name_alredy_exists);
				} else {
					test.addSite(
							site.getText().toString(),
							contact.getText().toString(),
							address.getText().toString(),
							city.getText().toString(),
							state.getText().toString(),
							zipcode.getText().toString(),
							phone.getText().toString(),
							fax.getText().toString()
					);
					if (option == 0) {
						createManagerDialog(1);
					} else {
						createTestSetupDialog();
					}
					dialog.dismiss();
				}
			}
		});

		dialog.show();
	}

	private void setSelOp(String op){
		selOp = op;
	}

	private void setSelSite(String site){
		selSite = site;
	}

	private void setSelObj(String obj){
		selObj = obj;
	}

	private void createOperatorDetailsDialog(String selectedOperator) {
		final Dialog dialog = new Dialog(this );
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_operator_details);
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}
		((TextView) dialog.findViewById(R.id.dlg_title)).setText(R.string.operator);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_operator);

		final String operat = selectedOperator;
		final TextView operator = dialog.findViewById(R.id.txt_operator);
		final TextView extension = dialog.findViewById(R.id.txt_extension);
		final TextView email = dialog.findViewById(R.id.txt_email);

		String[] details = test.getOperatorDetails(selectedOperator);

		operator.setText(selectedOperator);
		extension.setText(details[0]);
		email.setText(details[1]);

		View.OnClickListener onClose = view ->
		{
			createManagerDialog( 2 );
			dialog.dismiss();
		};
		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( onClose );

		final Button delete = dialog.findViewById(R.id.btn_operator_delete);

		delete.setOnClickListener(v -> {
			final Dialog dialog1 = new Dialog(context);
			dialog1.requestWindowFeature(Window.FEATURE_NO_TITLE);
			dialog1.setCanceledOnTouchOutside(false);
			dialog1.setContentView(R.layout.dialog_yes_no);
			if ( dialog1.getWindow() != null )
			{
				dialog1.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
				dialog1.getWindow().getAttributes().width = LayoutParams.WRAP_CONTENT;
				dialog1.getWindow().getAttributes().height = LayoutParams.WRAP_CONTENT;
			}

			((TextView)  dialog1.findViewById(R.id.dlg_title)).setText(R.string.operator_delete);
			((ImageView) dialog1.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_warning);

			final TextView message = dialog1.findViewById(R.id.message);
			message.setText(R.string.operator_delete_confirm);

			dialog1.findViewById( R.id.btn_close_dlg ).setOnClickListener(v1 -> dialog1.dismiss());
			dialog1.findViewById( R.id.btn_no ).setOnClickListener(v1 -> dialog1.dismiss());

			final Button btnYes = dialog1.findViewById(R.id.btn_yes);
			btnYes.setOnClickListener(v12 -> {
				if(test.getDefaultOperator().equals(operat)){
					test.setDefaultOperator("");
				}
				test.removeOperator(operat);
				createManagerDialog(2);
				dialog.dismiss();
				dialog1.dismiss();
			});

			dialog1.show();
		});

		final Button setDefault = dialog.findViewById(R.id.btn_operator_default);
		setDefault.setOnClickListener(v -> {
			test.removeOperator(operat);
			test.updateOperator(operator.getText().toString(), extension.getText().toString(), email.getText().toString());
			test.setDefaultOperator(operator.getText().toString());
			createManagerDialog(2);
			dialog.dismiss();
		});

		final Button save = dialog.findViewById(R.id.btn_operator_save);
		save.setOnClickListener(v -> {
			if(!operator.getText().toString().equals("")){
				test.removeOperator(operat);
				test.updateOperator(operator.getText().toString(), extension.getText().toString(), email.getText().toString());
				createManagerDialog(2);
				dialog.dismiss();
			}
		});

		dialog.show();
	}

	public void createTestSetupDialog() {
		final Dialog dialog = new Dialog(this );
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_test_setup);
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().getAttributes().width = LayoutParams.MATCH_PARENT;
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}
		((TextView) dialog.findViewById(R.id.dlg_title)).setText(R.string.test_setup);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_new);

		final Spinner  spinnerOperator = dialog.findViewById(R.id.spinner_operator);
		final Spinner  spinnerSite     = dialog.findViewById(R.id.spinner_sites);
		final TextView txtObject       = dialog.findViewById(R.id.txt_object_name);

		String[] operators = test.getOperatorsOrderByDefault();
		ArrayAdapter<String> dataAdapter = new ArrayAdapter<>( this, R.layout.simple_spinner_dropdown_item, operators );
		dataAdapter.setDropDownViewResource( android.R.layout.simple_spinner_dropdown_item );
		spinnerOperator.setAdapter( dataAdapter );

		String[] sites = test.getSitesForSpinner();
		ArrayAdapter<String> dataAdapterSite = new ArrayAdapter<>( this, R.layout.simple_spinner_dropdown_item, sites );
		dataAdapterSite.setDropDownViewResource( android.R.layout.simple_spinner_dropdown_item );
		spinnerSite.setAdapter( dataAdapterSite );

		View.OnClickListener onClose = view ->
		{
			dialog.dismiss();
			createManagerDialog( 0 );
		};

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( onClose );
		dialog.findViewById( R.id.btn_cancel ).setOnClickListener( onClose );

		final Button btnSave = dialog.findViewById(R.id.btn_save);
		btnSave.setOnClickListener(v -> {
			String site 	   =  String.valueOf( spinnerSite.getSelectedItem()     );
			String operator    =  String.valueOf( spinnerOperator.getSelectedItem() );
			String objectName  =  txtObject.getText().toString();
			if (!site.equals("") && !objectName.equals("")){
				test.New(site, operator);
				test.Save();

				if ( !objectName.equals("") ){
					test.addTestObject(objectName);
					test.setCurrentObject(objectName);
					enableButtonImage(R.id.btn_gps, true);
					enableButtonImage(R.id.btn_picture, true);
					adapter.clear();
					((TextView) findViewById(R.id.lb_test_number)).setText("- - -");
					((TextView) findViewById(R.id.lb_resistance)).setText("- - -");
					((TextView) findViewById(R.id.lb_resistance_270Hz)).setText("");
					((TextView) findViewById(R.id.lb_resistance_570Hz)).setText("");
					((TextView) findViewById(R.id.lb_resistance_870Hz)).setText("");
					((TextView) findViewById(R.id.lb_resistance_1170Hz)).setText("");
					((TextView) findViewById(R.id.lb_resistance_1470Hz)).setText("");
				}
				enableButtonImage(R.id.btn_objects, true);
				dialog.dismiss();
			}
		});

		dialog.show();
	}

	public void createObjectAddDialog() {
		final Dialog dialog = new Dialog(this );
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_object_new);
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}
		((TextView) dialog.findViewById(R.id.dlg_title)).setText(R.string.object_new);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_new);

		final TextView objectName = dialog.findViewById(R.id.txt_object_name);

		View.OnClickListener onClose = view ->
		{
			createObjectsDialog();
			dialog.dismiss();
		};

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( onClose );
		dialog.findViewById( R.id.btn_object_cancel ).setOnClickListener( onClose );

		final Button btnSave = dialog.findViewById(R.id.btn_object_save);
		btnSave.setOnClickListener(v -> {
			String objName = objectName.getText().toString();
			if(!objName.equals("")){
				if(test.objectExists(objName)){
					alert(R.string.object_name_alredy_exists);
				} else {
					test.addTestObject(objectName.getText().toString());
					enableButtonImage(R.id.btn_gps, true);
					enableButtonImage(R.id.btn_picture, true);
					adapter.clear();
					dialog.dismiss();
				}
			}
		});

		dialog.show();
	}

	public void showObjectsDialog(View view){
		createObjectsDialog();
	}

	public void createPicturePreviewDialog(View v) {
		if(permissionToPictureAccepted){
			picture();
		}
		else {
			requestPermission(REQUEST_PICTURE_PERMISSION);
		}
	}

	private void picture(){
		File file = test.getPictureFile();
		picture.showDialog(file);
	}

	public void pictureStatus(final int status){
		runOnUiThread(() -> {
			switch (status)
			{
				case Picture.WAIT:
					changeButtonImage(R.id.btn_picture, R.drawable.ic_wait, false);
					break;
				case Picture.FINISHED:
					changeButtonImage(R.id.btn_picture, R.drawable.ic_picture_small, true);
					break;
			}
		});
	}

	/*********************************************
	 * REG GPS INTERFACE
	 **********************************************/

	public void getGpsData(View v) {
		if(permissionToGPSAccepted){
			gps();
		}
		else {
			requestPermission(REQUEST_GPS_PERMISSION);
		}
	}

	private void gps(){
		gps = new String[5];
		gps[0] = test.getCurrentObject();
		if (test.getCurrentObject().equals("")) {
			return;
		}
		if ( test.getGpsData( test.getCurrentObject() )[0].equals("") ) {
			mGPS.getDataGPS();
		} else {
			mGPS.dialogConfirmReplace( test.getGpsData( test.getCurrentObject() ) );
		}
	}

	public void GpsData(int which, String[] data) {
		switch (which) {
			case GPS.RESULT:
				if (data != null) {
					gps[1] = data[0];
					gps[2] = data[1];
					gps[3] = data[2];
					gps[4] = data[3];
					test.addGpsData(gps);
					gps=null;

					enableButtonImage(R.id.btn_manager, true);
					enableButtonImage(R.id.btn_map, true);
					enableButtonImage(R.id.btn_objects, true);
					changeButtonImage(R.id.btn_gps, R.drawable.ic_gps_small, true);
				}
				break;
			case GPS.WAIT:
				enableButtonImage(R.id.btn_manager, false);
				enableButtonImage(R.id.btn_map, false);
				enableButtonImage(R.id.btn_objects, false);
				changeButtonImage(R.id.btn_gps, R.drawable.ic_wait, false);
				break;
			case GPS.CANCELLED:
				enableButtonImage(R.id.btn_manager, true);

				if ( test.getGpsData( test.getCurrentObject() )[0].equals("") ) {
					enableButtonImage(R.id.btn_map, false);
				} else {
					enableButtonImage(R.id.btn_map, true);
				}
				enableButtonImage(R.id.btn_objects, true);
				changeButtonImage(R.id.btn_gps, R.drawable.ic_gps_small, true);
				break;
		}
	}

	/*********************************************
	 * REG END
	 **********************************************/

	private void createManagerDialog(int index) {
		final Dialog dialog = new Dialog(this, R.style.MyThemeCompat);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_tab);
		if (dialog.getWindow() != null)
		{
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
			dialog.getWindow().getAttributes().width = LayoutParams.MATCH_PARENT;
		}

		final TabHost tabs = dialog.findViewById(R.id.tabhost);
		tabs.setup();
		tabs.getTabWidget().setDividerDrawable(R.drawable.tab_divider);

		View tabIndicator;

		tabIndicator = getTabIndicator( getResources().getString(R.string.files_manager), R.drawable.ic_manager_small, tabs );
        addTabSpec(tabIndicator, R.id.dlg_savedfiles, tabs);
        setTabSavedFilesFunctions(dialog);

        tabIndicator = getTabIndicator( getResources().getString(R.string.clients), R.drawable.ic_sites, tabs );
        addTabSpec(tabIndicator, R.id.dlg_sites, tabs);

        tabIndicator = getTabIndicator( getResources().getString(R.string.operators), R.drawable.ic_operator, tabs );
        addTabSpec(tabIndicator, R.id.dlg_operator, tabs);

        tabIndicator = getTabIndicator( getResources().getString(R.string.firm), R.drawable.ic_company, tabs );
        addTabSpec(tabIndicator, R.id.dlg_comp, tabs);

        tabs.setOnTabChangedListener(tabId -> {
			int i = tabs.getCurrentTab();
			switch (i) {
				case 0:
					setTabSavedFilesFunctions(dialog);
					break;
				case 1:
					setTabSitesFunctions(dialog);
					break;
				case 2:
					setTabOperatorsFunctions(dialog);
					break;
				case 3:
					setTabCompanyFunctions(dialog);
					break;
			}
		});

        final Button btnCancel = dialog.findViewById(R.id.btn_close_manager);
        btnCancel.setOnClickListener(v -> dialog.dismiss());

        tabs.setCurrentTab(index);
		dialog.show();
	}

	private View getTabIndicator(String description, int image, TabHost tabs){
		View tabIndicator = LayoutInflater.from(this).inflate(R.layout.tab_indicator, tabs.getTabWidget(), false);
		((TextView)  tabIndicator.findViewById(R.id.tab_title)).setText(description.toUpperCase(Locale.getDefault()));
		((ImageView) tabIndicator.findViewById(R.id.tab_icon)).setImageResource(image);
		return tabIndicator;
	}

	private void addTabSpec(View tabIndicator, int dialog, TabHost tabs){
		TabSpec spec = tabs.newTabSpec("tab_"+dialog);
        spec.setIndicator(tabIndicator);
        spec.setContent(dialog);
        tabs.addTab(spec);
	}

	private void checkGpsData(){
		enableButtonImage(R.id.btn_map, false);
		if(test.getObjects()!=null){
			for (String obj : test.getObjects()){
				String[] gps = test.getGpsData(obj);
				if(!gps[0].equals("")){
					enableButtonImage(R.id.btn_map, true);
					break;
				}
			}
		}
	}

	private void setTabSavedFilesFunctions(final Dialog dialog) {
		final ListView list = dialog.findViewById(R.id.list_savedfiles);
		final Button btnLoad = dialog.findViewById(R.id.btn_load);
		final Button btnDelete = dialog.findViewById(R.id.btn_delete);
		final Button btnNew = dialog.findViewById(R.id.btn_new);
		final Button btnEmail = dialog.findViewById(R.id.btn_email);

		enableButton(btnLoad, false);
		enableButton(btnDelete, false);
		enableButton(btnEmail, false);

		final ArrayList<ListSites> sites = test.getSavedFiles();
		final ListSitesDetails adapterListView;
        adapterListView = new ListSitesDetails(this, sites);
        list.setChoiceMode(ListView.CHOICE_MODE_SINGLE);
        list.setAdapter(adapterListView);

		list.setOnItemClickListener((parent, view, position, id) -> {
			String item = ((ListSites) parent.getItemAtPosition(position)).getUrl();
			selSite = item;
			setSelObj(item);
			selSiteIndex = position;
			adapterListView.setSelectedFileDetails(test.getDataFileDetails(item));
			adapterListView.setSelectedIndex(position);
			adapterListView.notifyDataSetChanged();
			enableButton(btnLoad, true);
			enableButton(btnDelete, true);
			enableButton(btnEmail, true);
		});

		if(test.getDataFolder() != null){
			selFileName = test.getDataFolder().getName();
			for (int i = 0; i < sites.size(); i++){
				if(sites.get(i).getUrl().equals(selFileName)){
					selFileIndex = i;
				}
			}
			selSite = selFileName;
			selSiteIndex = selFileIndex;
			adapterListView.setSelectedFileDetails( test.getDataFileDetails(selFileName) );
			adapterListView.setSelectedIndex( selFileIndex );
            list.setItemChecked(selFileIndex, true);
            adapterListView.notifyDataSetChanged();
            enableButton( btnLoad,   true );
			enableButton( btnDelete, true );
			enableButton( btnEmail,  true );
		}

		btnLoad.setOnClickListener(v -> {
			mGPS.cancel();
			selFileName = selSite;
			selFileIndex = selSiteIndex;
			test.loadDataFile(selFileName);
			test.setCurrentObject("");
			enableButtonImage(R.id.btn_objects, true);
			enableButtonImage(R.id.btn_sound, false);
			checkGpsData();
			dialog.dismiss();
			createObjectsDialog();
		});

		final ReportPDF reportPDF = new ReportPDF(this, handlerReport);

		btnEmail.setOnClickListener(v ->
		{
			if ( !selSite.equals("") )
			{
				if( dlgProgress == null )
					creatDialogProgress();
				dlgProgress.show();
				new Thread(() ->
				{
					reportPDF.generate( test, selSite );
					dlgProgress.dismiss();
				}).start();
			}
		});

		btnDelete.setOnClickListener(v -> {
			final Dialog dialog1 = new Dialog(context);
			dialog1.requestWindowFeature(Window.FEATURE_NO_TITLE);
			dialog1.setCanceledOnTouchOutside(false);
			dialog1.setContentView(R.layout.dialog_yes_no);
			if ( dialog1.getWindow() != null )
			{
				dialog1.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
				dialog1.getWindow().getAttributes().width = LayoutParams.WRAP_CONTENT;
				dialog1.getWindow().getAttributes().height = LayoutParams.WRAP_CONTENT;
			}

			((TextView)  dialog1.findViewById(R.id.dlg_title)).setText(R.string.file_delete);
			((ImageView) dialog1.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_warning);

			final TextView message = dialog1.findViewById(R.id.message);
			message.setText(R.string.file_delete_confirm);

			dialog1.findViewById( R.id.btn_close_dlg ).setOnClickListener(v1 -> dialog1.dismiss());
			dialog1.findViewById( R.id.btn_no ).setOnClickListener(v1 -> dialog1.dismiss());

			final Button btnYes = dialog1.findViewById(R.id.btn_yes);
			btnYes.setOnClickListener(v1 -> {
				if (!selSite.equals("")) {
					String name = selSite;
					selSite = "";
					test.deleteDataFile(name);
					if (name.equals(selFileName)) {
						mGPS.cancel();
						test.clear();
						selFileName = "";
						selFileIndex = -1;
						selSiteIndex = -1;
						adapter.clear();
						((TextView) findViewById(R.id.lb_test_number)).setText("- - -");
						((TextView) findViewById(R.id.lb_resistance)).setText("- - -");
						((TextView) findViewById(R.id.lb_resistance_270Hz)).setText("");
						((TextView) findViewById(R.id.lb_resistance_570Hz)).setText("");
						((TextView) findViewById(R.id.lb_resistance_870Hz)).setText("");
						((TextView) findViewById(R.id.lb_resistance_1170Hz)).setText("");
						((TextView) findViewById(R.id.lb_resistance_1470Hz)).setText("");
						enableButtonImage(R.id.btn_objects, false);
						enableButtonImage(R.id.btn_gps, false);
						enableButtonImage(R.id.btn_picture, false);
						enableButtonImage(R.id.btn_sound, false);
						enableButtonImage(R.id.btn_map, false);
					}
					test.setCurrentObject("");
					selObj = "";
					selTest = "";
					int index = adapterListView.getSelectedIndex();
					sites.remove(index);
					list.setItemChecked(-1, true);
					adapterListView.setSelectedIndex(-1);
					adapterListView.notifyDataSetChanged();
					enableButton(btnEmail, false);
					enableButton(btnLoad, false);
					enableButton(btnDelete, false);
				}
				dialog1.dismiss();
			});

			dialog1.show();

		});

		btnNew.setOnClickListener(v -> {
			enableButtonImage(R.id.btn_sound, false);
			if (test.getSitesForSpinner().length > 1){
				mGPS.cancel();
				createTestSetupDialog();
			} else {
				createSiteAddDialog(1);
			}
			dialog.dismiss();
		});
	}

	private void creatDialogProgress()
	{
		dlgProgress = new Dialog(this);
		dlgProgress.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dlgProgress.setCanceledOnTouchOutside(false);
		dlgProgress.setContentView(R.layout.progress_bar);
		((TextView) dlgProgress.findViewById(R.id.dlg_title)).setText(R.string.please_wait);
		((TextView) dlgProgress.findViewById(R.id.message)).setText(R.string.saving_data_in_pdf);
		dlgProgress.findViewById(R.id.dlg_icon).setVisibility(View.GONE);
	}

	private static class nHandler extends Handler {
		private final WeakReference<EM4058> mActivity;

		nHandler(EM4058 activity)
		{
			mActivity = new WeakReference<>(activity);
		}

		@Override
		public void handleMessage( @NonNull Message msg )
		{
			EM4058 activity = mActivity.get();
			if ( activity != null )
			{
				String status = (String) msg.obj;
				activity.ui( status );
			}
		}
	}

	private final nHandler handlerReport = new nHandler(this);

	private void ui(String msg){
		TextView txt = dlgProgress.findViewById(R.id.status);
		txt.setText(msg);
	}

	private void setTextTW( int id, String text )
	{
		if ( findViewById( id ) != null && findViewById( id ) instanceof TextView )
		{
			((TextView)findViewById( id )).setText( text );
		}
	}

	private void enableButton( int buttonId, boolean enable )
	{
		Button btn = findViewById( buttonId );
		int color = enable ? Color.WHITE : Color.DKGRAY;
		btn.setEnabled( enable );
		btn.setTextColor( color );
	}

	private void enableButton(Button btn, boolean enable){
		int color = enable ? Color.WHITE : Color.DKGRAY;
		btn.setEnabled(enable);
		btn.setTextColor(color);
	}

	private void enableButton(ImageButton btn, boolean enable){
		float alpha = enable ? (float) 1.0 : (float) 0.2;
		btn.setEnabled(enable);
		btn.setAlpha(alpha);
	}

	private void enableButtonImage( int buttonId, boolean enable )
	{
		ImageButton btn   = findViewById( buttonId );
		if ( btn == null )
			return;
		int alpha = enable ? 255 : 51;
		btn.setEnabled( enable );
		if ( btn.getDrawable() == null )
			return;
		btn.getDrawable().setAlpha( alpha );
	}

	public void changeButtonImage(int buttonId, int image, boolean enable){
		((ImageButton) findViewById(buttonId)).setImageResource(image);
		enableButtonImage(buttonId, enable);
	}

	private void enableButton(ImageButton btn, boolean enable, boolean hide){
		float alpha = enable ? (float) 1.0 : (float) 0.2;
		int visibility = hide ? View.VISIBLE : View.GONE;
		btn.setVisibility(visibility);
		btn.setEnabled(enable);
		btn.setAlpha(alpha);
	}

	private void setTabOperatorsFunctions(final Dialog dialog) {
		final ListView list = dialog.findViewById(R.id.list_operator);
		String[] operators;
		if ( test.getOperators() != null )
		{
			operators = test.getOperators();
			Arrays.sort( operators );
		}
		else
		{
			operators = new String[]{""};
		}

		ArrayAdapter<String> modeAdapter = new ArrayAdapter<>(this, R.layout.simple_list_item, R.id.text1, operators);
		list.setChoiceMode(1);
		list.setAdapter(modeAdapter);

		list.setOnItemClickListener( ( parent, view, position, id ) ->
		{
			if ( view instanceof TextView )
			{
				String item = ((TextView) view).getText().toString();
				item = item.replace( " " + getResources().getString( R.string.defaults ), "" );
				setSelOp( item );
			}
		} );

		final Button newOperator = dialog.findViewById(R.id.btn_operator_new);
		newOperator.setOnClickListener(v -> {
			createOperatorAddDialog();
			dialog.dismiss();
		});

		final Button editOperator = dialog.findViewById(R.id.btn_operator_edit);
		editOperator.setOnClickListener(v -> {
			if(!selOp.equals("")){
				String op = selOp;
				selOp = "";
				createOperatorDetailsDialog(op);
				dialog.dismiss();
			}
		});
	}

	private void setTabCompanyFunctions(final Dialog dialog) {
		String[] data = test.getCompany();

		final TextView company 	= dialog.findViewById(R.id.txt_company);
		final TextView address 	= dialog.findViewById(R.id.txt_address);
		final TextView city 	= dialog.findViewById(R.id.txt_city);
		final TextView state 	= dialog.findViewById(R.id.txt_state);
		final TextView zipcode 	= dialog.findViewById(R.id.txt_zip);
		final TextView phone 	= dialog.findViewById(R.id.txt_phone);
		final TextView fax 		= dialog.findViewById(R.id.txt_fax);

		if(data!=null){
			company.setText	(  data[0]	);
			address.setText	(  data[1]	);
			city.setText	(  data[2]	);
			state.setText	(  data[3]	);
			zipcode.setText	(  data[4]	);
			phone.setText	(  data[5]	);
			fax.setText		(  data[6]  );
		}

		final Button saveData = dialog.findViewById(R.id.btn_firm_save);
		saveData.setOnClickListener(v -> {
			test.updateCompany(
					company.getText().toString(),
					address.getText().toString(),
					city.getText().toString(),
					state.getText().toString(),
					zipcode.getText().toString(),
					phone.getText().toString(),
					fax.getText().toString()
			);
			dialog.dismiss();
		});

		final Button clear = dialog.findViewById(R.id.btn_firm_clean);
		clear.setOnClickListener(v -> {
			company.setText	("");
			address.setText	("");
			city.setText	("");
			state.setText	("");
			zipcode.setText	("");
			phone.setText	("");
			fax.setText		("");
		});
	}

	private void setTabSitesFunctions(final Dialog dialog){
		final ListView list = dialog.findViewById(R.id.list_sites);
		final Button newSite = dialog.findViewById(R.id.btn_sites_new);
		final Button deleteSite = dialog.findViewById(R.id.btn_site_delete);
		final Button editSite = dialog.findViewById(R.id.btn_sites_edit);
		enableButton(editSite, false);
		enableButton(deleteSite, false);

		final List<String> sites;
		if(test.getSites()!=null){
			sites = test.getSites();
			Collections.sort(sites);
		} else {
			sites = new ArrayList<>();
		}

		final ArrayAdapter<String> modeAdapter = new ArrayAdapter<>(this, R.layout.simple_list_item, R.id.text1, sites);
		list.setChoiceMode(1);
		list.setAdapter(modeAdapter);

		list.setOnItemClickListener((parent, view, position, id) -> {
			String item = ((TextView)view).getText().toString();
			setSelSite(item);
			selSiteIndex = position;
			enableButton(editSite, true);
			enableButton(deleteSite, true);
		});

		newSite.setOnClickListener(v -> {
			createSiteAddDialog(0);
			selSiteIndex = -1;
			dialog.dismiss();
		});

		editSite.setOnClickListener(v -> {
			if(!selSite.equals("")){
				String site = selSite;
				selSite = "";
				selSiteIndex = -1;
				createSiteDetailsDialog(site);
				dialog.dismiss();
			}
		});

		deleteSite.setOnClickListener(v -> {
			final Dialog dialog1 = new Dialog(context);
			dialog1.requestWindowFeature(Window.FEATURE_NO_TITLE);
			dialog1.setCanceledOnTouchOutside(false);
			dialog1.setContentView(R.layout.dialog_yes_no);
			if ( dialog1.getWindow() != null )
			{
				dialog1.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
				dialog1.getWindow().getAttributes().width = LayoutParams.WRAP_CONTENT;
				dialog1.getWindow().getAttributes().height = LayoutParams.WRAP_CONTENT;
			}

			((TextView)  dialog1.findViewById(R.id.dlg_title)).setText(R.string.site_delete);
			((ImageView) dialog1.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_warning);

			final TextView message = dialog1.findViewById(R.id.message);
			message.setText(R.string.site_delete_confirm);

			dialog1.findViewById( R.id.btn_close_dlg ).setOnClickListener(v1 -> dialog1.dismiss());
			dialog1.findViewById( R.id.btn_no ).setOnClickListener(v1 -> dialog1.dismiss());

			final Button btnYes = dialog1.findViewById(R.id.btn_yes);
			btnYes.setOnClickListener(v1 -> {
				if (!selSite.equals("") && selSiteIndex != -1) {
					String name = selSite;
					selSite = "";
					test.removeSite(name);
					int index = selSiteIndex;
					selSiteIndex = -1;
					sites.remove(index);
					list.setItemChecked(-1, true);
					modeAdapter.notifyDataSetChanged();
					enableButton(editSite, false);
					enableButton(deleteSite, false);
				}
				dialog1.dismiss();
			});

			dialog1.show();
		});
	}

	public void showMap( View view )
	{
		if ( permissionToMemoryAccepted )
		{
			map();
		}
		else
		{
			requestPermission( REQUEST_MEMORY_MAP_PERMISSION );
		}
	}

	private void map()
	{
		if ( test != null && !test.getCurrentTestSiteName().equals( "" ) )
		{
			ArrayList<MapData> mapDataList = new ArrayList<>();
			for ( String obj : test.getObjects() )
			{
				final String[] pos = test.getGpsData( obj );
				if ( !pos[0].equals( "" ) && !pos[1].equals( "" ) )
				{

					MapData mapData = new MapData(
							test.getCurrentObject(),
							Double.parseDouble( pos[0] ),
							Double.parseDouble( pos[1] ),
							pos[2],
							pos[3]
					);
					mapDataList.add( mapData );
				}
			}
			if ( !mapDataList.isEmpty() )
			{
				gMap.showMap( test.getPictureFile( "snapshot" ), mapDataList );
			}
		}
	}

	private void createObjectsDialog() {
		indexOfSelObject = -1;
		final Dialog dialog = new Dialog(this, R.style.MyThemeCompat);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setCancelable(false);
		dialog.setContentView(R.layout.dialog_test_details);
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().setBackgroundDrawable(new ColorDrawable(Color.TRANSPARENT));
			dialog.getWindow().getAttributes().width = LayoutParams.MATCH_PARENT;
			dialog.getWindow().getAttributes().height = LayoutParams.MATCH_PARENT;
		}
		((TextView) dialog.findViewById(R.id.dlg_title)).setText(R.string.tests_details);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_details_50);

		final TextView testsite    = dialog.findViewById(R.id.txt_testsite);
		final TextView contact     = dialog.findViewById(R.id.txt_contact);
		final TextView address     = dialog.findViewById(R.id.txt_address);
		final TextView city        = dialog.findViewById(R.id.txt_city);
		final TextView ope         = dialog.findViewById(R.id.txt_operator);
		final String   currentSite = test.getCurrentTestSiteName();
		String[]       siteDetails = test.getFileSiteDetails();
		String[]       operator    = test.getOperatorFromFile();

		testsite .setText( currentSite    );
		contact  .setText( siteDetails[0] );
		address  .setText( siteDetails[1] );
		city     .setText( siteDetails[2] );
		ope      .setText( operator[0]    );

		final Button edit         = dialog.findViewById(R.id.btn_edit);
		final Button deleteObject = dialog.findViewById(R.id.btn_object_delete);
		final Button newObject    = dialog.findViewById(R.id.btn_object_new);
		final Button editObject   = dialog.findViewById(R.id.btn_object_edit);
		final Button cancel       = dialog.findViewById(R.id.btn_object_cancel);
		final Button comments     = dialog.findViewById(R.id.btn_comments);

		cancel.setText(R.string.close);
		enableButton(editObject, false);
		enableButton(deleteObject, false);

		final ListView list = dialog.findViewById(R.id.list_object);
		final List<String> obj = test.getObjectsList();
		final ArrayAdapter<String> modeAdapter = new ArrayAdapter<>(this, R.layout.simple_list_item, R.id.text1, obj);
		list.setChoiceMode(1);
		list.setAdapter(modeAdapter);

		final TextView lblObj = dialog.findViewById(R.id.lbl_obj_list);
		lblObj.append(" (" + obj.size() + ")");

		final TextView lblObs = dialog.findViewById(R.id.lbl_obs);

		if(!test.getCurrentObject().equals("")){
			setSelObj(test.getCurrentObject());
			for(int i = 0; i < obj.size(); i++ ){
				if(test.getCurrentObject().equals(obj.get(i))){
					indexOfSelObject = i;
					lblObs.setVisibility(View.GONE);
					cancel.setText(R.string.ready_measure);
					enableButton(editObject, true);
					enableButton(deleteObject, true);
				}
			}
		}

		if(indexOfSelObject > -1){
			list.setItemChecked(indexOfSelObject, true);
			list.smoothScrollToPosition(indexOfSelObject);
		}

		list.setOnItemClickListener((parent, view, position, id) -> {
			String objName = ((TextView)view).getText().toString();
			indexOfSelObject = position;
			list.setItemChecked(indexOfSelObject, true);
			setSelObj(objName);
			test.setCurrentObject(objName);
			enableButtonImage(R.id.btn_gps, true);
			lblObs.setVisibility(View.GONE);
			enableButtonImage(R.id.btn_picture, true);
			cancel.setText(R.string.ready_measure);
			enableButton(editObject, true);
			enableButton(deleteObject, true);
		});

	    deleteObject.setOnClickListener(v -> {
			final Dialog dialog1 = new Dialog(context);
			dialog1.requestWindowFeature(Window.FEATURE_NO_TITLE);
			dialog1.setCanceledOnTouchOutside(false);
			dialog1.setContentView(R.layout.dialog_yes_no);
			if ( dialog1.getWindow() != null )
			{
				dialog1.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
				dialog1.getWindow().getAttributes().width = LayoutParams.WRAP_CONTENT;
				dialog1.getWindow().getAttributes().height = LayoutParams.WRAP_CONTENT;
			}

			((TextView)  dialog1.findViewById(R.id.dlg_title)).setText(R.string.object_delete);
			((ImageView) dialog1.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_warning);

			final TextView message = dialog1.findViewById(R.id.message);
			message.setText(R.string.object_delete_confirm);

			dialog1.findViewById( R.id.btn_close_dlg ).setOnClickListener(v1 -> dialog1.dismiss());
			dialog1.findViewById( R.id.btn_no ).setOnClickListener(v1 -> dialog1.dismiss());

			final Button btnYes = dialog1.findViewById(R.id.btn_yes);
			btnYes.setOnClickListener(v1 -> {
				if (!selObj.equals("")) {
					String name = selObj;
					selObj = "";
					if (test.getCurrentObject().equals(name)) {
						test.setCurrentObject("");
						adapter.clear();
						enableButtonImage(R.id.btn_gps, false);
						enableButtonImage(R.id.btn_picture, false);
						enableButtonImage(R.id.btn_sound, false);
						enableButtonImage(R.id.btn_map, false);
					}
					test.removeObject(name);
					obj.remove(indexOfSelObject);
					indexOfSelObject = -1;
					list.setItemChecked(-1, true);
					modeAdapter.notifyDataSetChanged();
					lblObs.setVisibility(View.VISIBLE);
					cancel.setText(R.string.close);
					enableButton(editObject, false);
					enableButton(deleteObject, false);
					checkGpsData();
				}
				dialog1.dismiss();
			});

			dialog1.show();
		});

	    edit.setOnClickListener(v -> {
			updateTestsiteDetails(currentSite);
			dialog.dismiss();
		});

		newObject.setOnClickListener(v -> {
			setSelObj("");
			createObjectAddDialog();
			dialog.dismiss();
		});

		editObject.setOnClickListener(v -> {
			if(!selObj.equals("")){
				createObjectTestDetailsDialog();
			}
		});

		View.OnClickListener onClose = view ->
		{
			if ( !test.getCurrentObject().equals( "" ) )
			{
				ArrayList<EM4058test.EM4058values> tests = test.getTestResults( test.getCurrentObject() );
				adapter.addAll( tests );
			}
			setSelObj( "" );
			dialog.dismiss();
		};

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( onClose );
		cancel.setOnClickListener( onClose );

		comments.setOnClickListener(v -> {
			createCommentsDialog();
			dialog.dismiss();
		});

		dialog.show();
	}

	private void updateTestsiteDetails(String selectedSite) {
		final Dialog dialog = new Dialog(this, R.style.MyThemeCompat);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_site);
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().getAttributes().width = LayoutParams.MATCH_PARENT;
			dialog.getWindow().getAttributes().height = LayoutParams.MATCH_PARENT;
		}
		((TextView) dialog.findViewById(R.id.dlg_title)).setText(R.string.site_edit);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_edit);

		final TextView lblOperator = dialog.findViewById(R.id.lbl_operator_sel);
		final Spinner  spinner = dialog.findViewById(R.id.spinner_operator);
		final TextView required = dialog.findViewById(R.id.lbl_required);
		final TextView site = dialog.findViewById(R.id.txt_site);
		final TextView contact = dialog.findViewById(R.id.txt_site_contact);
		final TextView address = dialog.findViewById(R.id.txt_site_address);
		final TextView city = dialog.findViewById(R.id.txt_site_city);
		final TextView state = dialog.findViewById(R.id.txt_site_state);
		final TextView zipcode = dialog.findViewById(R.id.txt_site_zip);
		final TextView phone = dialog.findViewById(R.id.txt_site_phone);
		final TextView fax = dialog.findViewById(R.id.txt_site_fax);

		final String[] currentOp = test.getOperatorFromFile();
		final String operator = currentOp[0];
		String[] operators;
		String[] op = test.getOperators();
		if(!operator.equals("")){
			operators = new String[op.length+2];
			operators[0] = operator;
			operators[1] = "";
			System.arraycopy(op, 0, operators, 2, op.length);
		} else {
			operators = new String[op.length+1];
			operators[0] = "";
			System.arraycopy(op, 0, operators, 1, op.length);
		}

		ArrayAdapter<String> dataAdapter = new ArrayAdapter<>( this, R.layout.simple_spinner_dropdown_item, operators );
		dataAdapter.setDropDownViewResource( android.R.layout.simple_spinner_dropdown_item );
		spinner.setAdapter( dataAdapter );

		lblOperator.setVisibility(View.VISIBLE);
		spinner.setVisibility(View.VISIBLE);
		required.setVisibility(View.GONE);
		site.setKeyListener(null);
		site.setClickable(false);
		site.setEnabled(false);
		site.setTextColor(0x66FFFFFF);

		String[] details = test.getFileSiteDetails();
		site.setText	( selectedSite );
		contact.setText	( details[0] );
		address.setText	( details[1] );
		city.setText	( details[2] );
		state.setText	( details[3] );
		zipcode.setText	( details[4] );
		phone.setText	( details[5] );
		fax.setText		( details[6] );

		View.OnClickListener onClose = view ->
		{
			createObjectsDialog();
			dialog.dismiss();
		};

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( onClose );
		dialog.findViewById( R.id.btn_site_cancel ).setOnClickListener( onClose );

		final Button save = dialog.findViewById(R.id.btn_site_save);
		save.setOnClickListener(v -> {
			String selOp = String.valueOf(spinner.getSelectedItem());
			String[] newOp = new String[3];
			if(selOp.equals(operator)){
				newOp[0] = currentOp[0];
				newOp[1] = currentOp[1];
				newOp[2] = currentOp[2];
			} else {
				String[] temp = test.getOperatorDetails(selOp);
				newOp[0] = selOp;
				newOp[1] = temp[0];
				newOp[2] = temp[1];
			}
			test.updateSiteInFile(
					contact.getText().toString(),
					address.getText().toString(),
					city.getText().toString(),
					state.getText().toString(),
					zipcode.getText().toString(),
					phone.getText().toString(),
					fax.getText().toString(),
					newOp[0], newOp[1], newOp[2]);
			createObjectsDialog();
			dialog.dismiss();
		});

		dialog.show();
	}

	private void createCommentsDialog()
	{
		final Dialog dialog = new Dialog( this, R.style.MyThemeCompat );
		dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dialog.setCanceledOnTouchOutside( false );
		dialog.setContentView( R.layout.dialog_comments );
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().getAttributes().width = LayoutParams.MATCH_PARENT;
			dialog.getWindow().getAttributes().height = LayoutParams.MATCH_PARENT;
		}
		((TextView) dialog.findViewById( R.id.dlg_title )).setText( R.string.comments );
		((ImageView) dialog.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_edit );

		final EditText comments = dialog.findViewById( R.id.txt_comments );
		comments.setText( test.getComments() );

		View.OnClickListener onClose = v ->
		{
			createObjectsDialog();
			dialog.dismiss();
		};

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( onClose );
		dialog.findViewById( R.id.btn_cancel ).setOnClickListener( onClose );

		dialog.findViewById( R.id.btn_save ).setOnClickListener( v ->
		{
			test.addComments( comments.getText().toString() );
			createObjectsDialog();
			dialog.dismiss();
		} );

		dialog.show();
	}

	public void showSavedFiles(View v){
		if(permissionToMemoryAccepted){
			createManagerDialog(0);
		}
		else {
			requestPermission(REQUEST_MEMORY_PERMISSION);
		}
	}

	public void recording(boolean isRecording){
		TextView     duration  = dlgAudio.findViewById(R.id.txt_duration);
		Chronometer  chrono    = dlgAudio.findViewById(R.id.chrono);
		ImageButton	 btnClose  = dlgAudio.findViewById(R.id.btn_close_dlg);
		ImageButton	 btnRecord = dlgAudio.findViewById(R.id.btn_record);
		ImageButton	 btnStop   = dlgAudio.findViewById(R.id.btn_stop_recording);
		ImageButton	 btnPlay   = dlgAudio.findViewById(R.id.btn_play);

		if (isRecording){
			enableButton(btnClose, false);
			enableButton(btnPlay, false);
			enableButton(btnRecord, false, false);
			enableButton(btnStop, true, true);
			chrono.setBase(SystemClock.elapsedRealtime());
			chrono.setOnChronometerTickListener(chronometer -> {
				CharSequence mm = chronometer.getText().subSequence(0, 2);
				CharSequence ss = chronometer.getText().subSequence(3, 5);
				if (mm.equals("01") && ss.equals("00")) {
					chronometer.setText("60/60s");
				} else {
					chronometer.setText(ss + "/60s");
				}
			});
			chrono.start();
		} else {
			enableButton(btnClose, true);
			enableButton(btnPlay, true);
			enableButton(btnRecord, true, true);
			enableButton(btnStop, false, false);
			chrono.stop();
			chrono.setText("00/60s");
			int seconds = audio.getAudioLenght() / 1000;
			duration.setText(seconds + " s");
		}
	}

	public void playing(boolean isPlaying){
		Chronometer  chrono    = dlgAudio.findViewById(R.id.chrono);
		ImageButton	 btnRecord = dlgAudio.findViewById(R.id.btn_record);
		ImageButton	 btnPlay   = dlgAudio.findViewById(R.id.btn_play);
		ImageButton	 btnStop   = dlgAudio.findViewById(R.id.btn_stop);

		if ( isPlaying )
		{
			enableButton( btnRecord, false );
			enableButton( btnPlay, false, false );
			enableButton( btnStop, true, true );
			chrono.setBase( SystemClock.elapsedRealtime() );
			chrono.setOnChronometerTickListener( chronometer ->
			{
				CharSequence mm = chronometer.getText().subSequence( 0, 2 );
				CharSequence ss = chronometer.getText().subSequence( 3, 5 );
				if ( mm.equals( "01" ) && ss.equals( "00" ) )
				{
					chronometer.setText( "60/60s" );
				}
				else
				{
					chronometer.setText( ss + "/60s" );
				}
			} );
			chrono.start();
		}
		else
		{
			enableButton( btnRecord, true );
			enableButton( btnPlay, true, true );
			enableButton( btnStop, false, false );
			chrono.stop();
			chrono.setText( "00/60s" );
		}
	}

	public void record(View v){
		if(permissionToRecordAccepted){
			audio();
		}
		else {
			requestPermission(REQUEST_RECORD_AUDIO_PERMISSION);
		}
	}

	private void audio(){
		if ( !test.getCurrentObject().equals("") && !test.getCurrentTestNumber().equals("") ) {
			if (dlgAudio == null){
				dlgAudio = createAudioDialog();
			}

			File location  = test.getDataFolder();
			String object  = test.getCurrentObjectClean();
			String testNum = test.getCurrentTestNumber();
			audio.setAudioFile( location, object, testNum );

			Chronometer  chrono = dlgAudio.findViewById(R.id.chrono);
			TextView duration   = dlgAudio.findViewById(R.id.txt_duration);
			ImageButton btnPlay = dlgAudio.findViewById(R.id.btn_play);
			TextView objectName = dlgAudio.findViewById(R.id.txt_object_name);
			TextView testNumber = dlgAudio.findViewById(R.id.txt_test_number);

			objectName.setText( test.getCurrentObject() );
			testNumber.setText( test.getCurrentTestNumber() );

			if(audio.fileExists()){
				int seconds = audio.getAudioLenght() / 1000;
				duration.setText(seconds + " s");
				enableButton(btnPlay, true);
			} else {
				duration.setText("");
				chrono.setBase(SystemClock.elapsedRealtime());
				enableButton(btnPlay, false);
			}
			dlgAudio.show();
			dlgAudio.setOnDismissListener(arg0 -> {
				if( audio.getAudioLenght() > 0 ){
					if(adapter.getItem(adapter.getCount()-1).getTestNumber()==Integer.parseInt(test.getCurrentTestNumber())){
						adapter.getItem(adapter.getCount()-1).setAudioPath(audio.getOutputFile());
						adapter.repaint();
					}
				}
			});
		}
	}

	private Dialog createAudioDialog() {
		final Dialog dialog = new Dialog(this);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_audio);
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}

		((TextView)  dialog.findViewById(R.id.dlg_title)).setText(R.string.voice_annotation);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_audio);

		final ImageButton btnRecord     = dialog.findViewById(R.id.btn_record);
		final ImageButton btnStopRecord = dialog.findViewById(R.id.btn_stop_recording);
		final ImageButton btnPlay       = dialog.findViewById(R.id.btn_play);
		final ImageButton btnStop       = dialog.findViewById(R.id.btn_stop);
		final Chronometer chrono        = dialog.findViewById(R.id.chrono);

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( vi -> dialog.dismiss() );

		btnRecord.setOnClickListener(v -> {
			chrono.setVisibility(View.VISIBLE);
			audio.startRecording();
		});

		btnStopRecord.setOnClickListener(v -> audio.stopRecording());

		btnPlay.setOnClickListener(v -> audio.startPlaying());

		btnStop.setOnClickListener(v -> audio.stopPlaying());

		dialog.setOnShowListener(dialog1 -> chrono.setText("00/60s"));

		return dialog;
	}

	private void createObjectTestDetailsDialog() {
		final Dialog dialog = new Dialog( this, R.style.MyThemeCompat );
		dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dialog.setCanceledOnTouchOutside( false );
		dialog.setContentView( R.layout.dialog_object_details );
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().getAttributes().width = LayoutParams.MATCH_PARENT;
			dialog.getWindow().getAttributes().height = LayoutParams.MATCH_PARENT;
		}
		((TextView) dialog.findViewById( R.id.dlg_title )).setText( R.string.tests_list );
		((ImageView) dialog.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_details_50 );

		final TextView lblName      = dialog.findViewById(R.id.lbl_object_name);
		final TextView lblNumTests  = dialog.findViewById(R.id.lbl_num_tests);
		final TextView txtLongitude = dialog.findViewById(R.id.txt_longitude);
		final TextView txtLatitude  = dialog.findViewById(R.id.txt_latitude);
		final TextView txtAltitude  = dialog.findViewById(R.id.txt_altitude);
		final TextView txtAccuracy  = dialog.findViewById(R.id.txt_accuracy);
		final Button   btnVoice     = dialog.findViewById(R.id.btn_object_play);
		final Button   deleteTest   = dialog.findViewById(R.id.btn_delete);
		final Button   deleteAudio  = dialog.findViewById(R.id.btn_del_audio);

		dialog.findViewById( R.id.tm25r_test_list_title ).setVisibility( View.GONE );
		dialog.findViewById( R.id.em4058_test_list_title ).setVisibility( View.VISIBLE );


		final File imgFile = test.getPictureFile( selObj );

		if ( imgFile.exists() )
		{
			ImageView imgThumb = dialog.findViewById( R.id.img_thumb );
			Bitmap img = BitmapFactory.decodeFile( imgFile.getAbsolutePath() );
			Bitmap thumb = ThumbnailUtils.extractThumbnail( img, 200, 200 );
			imgThumb.setImageBitmap( thumb );

			imgThumb.setOnClickListener( v ->
			{
				if ( permissionToPictureAccepted )
				{
					dialog.dismiss();
					OnDismissListener onDismissListener = dialog13 -> createObjectTestDetailsDialog();
					picture.showDialog( imgFile, onDismissListener );
				}
				else
				{
					requestPermission( REQUEST_PICTURE_PERMISSION );
				}
			} );
		}

		enableButton( deleteAudio, false );
		enableButton( deleteTest, false );
		enableButton( btnVoice, false );
		lblName.setText( selObj );

		String[] gps = test.getGpsData( selObj );

		txtLongitude.setText(gps[0]+"");
		txtLatitude.setText(gps[1]+"");
		txtAltitude.setText(gps[2]+"");
		txtAccuracy.setText(gps[3]+"");

		final ListView list = dialog.findViewById( R.id.list_object_details );
		final ArrayList<EM4058test.EM4058values> tests = test.getTestResults( selObj );
		final EM4058TableBaseAdapter adapterListView = new EM4058TableBaseAdapter( this );
		adapterListView.addAll( tests );
		list.setChoiceMode( ListView.CHOICE_MODE_SINGLE );
		list.setAdapter( adapterListView );

		list.setOnItemClickListener( ( parent, view, position, id ) ->
		{
			EM4058test.EM4058values currentTest = adapterListView.getItem( position );
			selTest = currentTest.getTestNumber() + "";

			if ( !currentTest.getAudioPath().equals( "" ) )
			{
				audio.setAudioFile( currentTest.getAudioPath() );
				enableButton( deleteAudio, true );
			}
			else
			{
				audio.setAudioFile( test.getDataFolder(), currentTest.getObjectName(), currentTest.getTestNumber() + "" );
				enableButton( deleteAudio, false );
			}
			enableButton( btnVoice, true );
			enableButton( deleteTest, true );
			indexOfSelTest = position;
		} );

        lblNumTests.setText(  adapterListView.getCount() + ""  );

        btnVoice.setOnClickListener(v -> {
			if(permissionToRecordAccepted){
				if (dlgAudio == null){
					dlgAudio = createAudioDialog();
				}
				final EM4058test.EM4058values currentTest = tests.get(indexOfSelTest);
				indexOfSelTest = -1;
				Chronometer chrono     = dlgAudio.findViewById(R.id.chrono);
				TextView    objectName = dlgAudio.findViewById(R.id.txt_object_name);
				TextView    testNumber = dlgAudio.findViewById(R.id.txt_test_number);
				TextView    duration   = dlgAudio.findViewById(R.id.txt_duration);
				ImageButton btnPlay    = dlgAudio.findViewById(R.id.btn_play);

				objectName.setText( currentTest.getObjectName() );
				testNumber.setText( currentTest.getTestNumber()+"" );
				if(audio.fileExists()){
					int seconds = audio.getAudioLenght() / 1000;
					duration.setText(seconds + " s");
					enableButton(btnPlay, true);
				} else {
					duration.setText("");
					chrono.setBase(SystemClock.elapsedRealtime());
					enableButton(btnPlay, false);
				}
				dlgAudio.show();
				dlgAudio.setOnDismissListener(arg0 -> {
					if (audio.getAudioLenght() > 0) {
						currentTest.setAudioPath(audio.getOutputFile());
					}
					list.setItemChecked(-1, true);
					adapterListView.notifyDataSetChanged();
				});
				enableButton(deleteAudio, false);
				enableButton(deleteTest, false);
				enableButton(btnVoice, false);
			}
			else {
				requestPermission(REQUEST_RECORD_AUDIO_PERMISSION);
			}
		});

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( v -> dialog.dismiss() );
		dialog.findViewById( R.id.btn_object_cancel ).setOnClickListener( v -> dialog.dismiss() );

	    deleteTest.setOnClickListener(v -> {
			final Dialog dialog12 = new Dialog(context);
			dialog12.requestWindowFeature(Window.FEATURE_NO_TITLE);
			dialog12.setCanceledOnTouchOutside(false);
			dialog12.setContentView(R.layout.dialog_yes_no);
			if ( dialog12.getWindow() != null )
			{
				dialog12.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
				dialog12.getWindow().getAttributes().width = LayoutParams.WRAP_CONTENT;
				dialog12.getWindow().getAttributes().height = LayoutParams.WRAP_CONTENT;
			}

			((TextView)  dialog12.findViewById(R.id.dlg_title)).setText(R.string.test_delete);
			((ImageView) dialog12.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_warning);

			final TextView message = dialog12.findViewById(R.id.message);
			message.setText(R.string.test_delete_confirm);

			dialog12.findViewById(R.id.btn_close_dlg).setOnClickListener(v14 -> dialog12.dismiss());
			dialog12.findViewById(R.id.btn_no).setOnClickListener(v14 -> dialog12.dismiss());

			final Button btnYes = dialog12.findViewById(R.id.btn_yes);
			btnYes.setOnClickListener(v13 -> {
				if (indexOfSelTest != -1) {
					test.removeTest(selObj, selTest);
					tests.remove(indexOfSelTest);
					indexOfSelTest = -1;
					list.setItemChecked(-1, true);
					adapterListView.notifyDataSetChanged();
					enableButton(deleteAudio, false);
					enableButton(deleteTest, false);
					enableButton(btnVoice, false);
				}
				dialog12.dismiss();
			});

			dialog12.show();
		});

	    deleteAudio.setOnClickListener(v -> {
			final Dialog dialog1 = new Dialog(context);
			dialog1.requestWindowFeature(Window.FEATURE_NO_TITLE);
			dialog1.setCanceledOnTouchOutside(false);
			dialog1.setContentView(R.layout.dialog_yes_no);
			if ( dialog1.getWindow() != null )
			{
				dialog1.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
				dialog1.getWindow().getAttributes().width = LayoutParams.WRAP_CONTENT;
				dialog1.getWindow().getAttributes().height = LayoutParams.WRAP_CONTENT;
			}

			((TextView)  dialog1.findViewById(R.id.dlg_title)).setText(R.string.audio_delete);
			((ImageView) dialog1.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_warning);

			final TextView message = dialog1.findViewById(R.id.message);
			message.setText(R.string.audio_delete_confirm);

			dialog1.findViewById( R.id.btn_close_dlg ).setOnClickListener(v12 -> dialog1.dismiss());
			dialog1.findViewById( R.id.btn_no ).setOnClickListener(v12 -> dialog1.dismiss());

			final Button btnYes = dialog1.findViewById(R.id.btn_yes);
			btnYes.setOnClickListener(v1 -> {
				if (indexOfSelTest != -1) {
					test.removeTestAudio(selObj, selTest);
					tests.get(indexOfSelTest).setAudioPath("");
					indexOfSelTest = -1;
					list.setItemChecked(-1, true);
					adapterListView.notifyDataSetChanged();
					enableButton(deleteAudio, false);
					enableButton(deleteTest, false);
					enableButton(btnVoice, false);
				}
				dialog1.dismiss();
			});

			dialog1.show();
		});

		dialog.show();
	}

	private void createOperatorAddDialog() {
		final Dialog dialog = new Dialog(this );
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_operator_details);
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}
		((TextView) dialog.findViewById(R.id.dlg_title)).setText(R.string.operator);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_operator);

		final TextView operator = dialog.findViewById(R.id.txt_operator);
		final TextView extension = dialog.findViewById(R.id.txt_extension);
		final TextView email = dialog.findViewById(R.id.txt_email);

		View.OnClickListener onClose = view ->
		{
			createManagerDialog( 2 );
			dialog.dismiss();
		};
		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( onClose );

		final Button setDefault = dialog.findViewById(R.id.btn_operator_default);
		setDefault.setVisibility(View.GONE);
		final Button delete = dialog.findViewById(R.id.btn_operator_delete);
		delete.setVisibility(View.GONE);

		final Button save = dialog.findViewById(R.id.btn_operator_save);
		save.setOnClickListener(v -> {
			String opName = operator.getText().toString();
			if(!"".equals(opName)){
				if(test.operatorExists(opName)){
					alert(R.string.operator_name_alredy_exists);
				} else {
					test.addOperator(opName, extension.getText().toString(), email.getText().toString());
					createManagerDialog(2);
					dialog.dismiss();
				}
			}
		});
		dialog.show();
	}

	private void isConnected( boolean isConnected )
	{
		h2.removeCallbacks( runFIFO );
		FIFO.clear();

		if ( menu != null && menu.findItem( R.id.connect ) != null )
			menu.findItem( R.id.connect ).setVisible( !isConnected );
		if ( menu != null && menu.findItem( R.id.disconnect ) != null )
			menu.findItem( R.id.disconnect ).setVisible( isConnected );
		if ( menu != null && menu.findItem( R.id.changedevice ) != null )
			menu.findItem( R.id.changedevice ).setVisible( !isConnected );

		enableButton( R.id.btTest, isConnected );
		enableButtonImage( R.id.btnPrint, isConnected );
		enableButtonImage( R.id.btnR, isConnected );
		enableButtonImage( R.id.btnRo, isConnected );

		changeAlpha( 1, isConnected );

		if ( isConnected )
		{
			h2.postDelayed( runFIFO, FIFO_TIME );
		}
		else
		{
			updateBatteryIcon( 0 );
			isTestRunning = false;
			testStopped = false;
		}
	}

	private void alert(int msg) {
		final Dialog dialog = new Dialog(context);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_yes_no);
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
			dialog.getWindow().getAttributes().width = LayoutParams.WRAP_CONTENT;
			dialog.getWindow().getAttributes().height = LayoutParams.WRAP_CONTENT;
		}

		((TextView)  dialog.findViewById(R.id.dlg_title)).setText(R.string.warning);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_warning);

		final TextView message = dialog.findViewById(R.id.message);
		message.setText(msg);

		final Button btnNo = dialog.findViewById(R.id.btn_no);
		btnNo.setText(R.string.close);
		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener(v1 -> dialog.dismiss());
		btnNo.setOnClickListener(v1 -> dialog.dismiss());

		final Button btnYes = dialog.findViewById(R.id.btn_yes);
		btnYes.setVisibility(View.GONE);

		dialog.show();
	}

	private void createConnectionDialog()
	{
		final Dialog dialog = new Dialog( this );
		dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dialog.setCanceledOnTouchOutside( false );
		dialog.setContentView( R.layout.dialog_yes_no );
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}
		((TextView) dialog.findViewById( R.id.dlg_title )).setText( R.string.equipment_not_found );
		((ImageView) dialog.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_connection );

		final TextView message = dialog.findViewById( R.id.message );
		message.setText( R.string.try_again );

		View.OnClickListener close = view ->
		{
			enableManagerBar( true );
			dialog.dismiss();
		};

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( close );
		dialog.findViewById( R.id.btn_no ).setOnClickListener( close );

		dialog.findViewById( R.id.btn_yes ).setOnClickListener( v ->
		{
			messageBox( R.string.wait, COLOR_YELLOW, true );
			h2.postDelayed( this::connecting, 5000 );
			dialog.dismiss();
		} );

		dialog.setOnCancelListener( dialog1 -> enableManagerBar( true ) );

		dialog.show();
	}

	public void closeApp()
	{
		try
		{
			isDisconnectedByUser = true;
			disconnect();
			if ( mGPS != null )
			{
				mGPS.cancel();
			}
			if ( picture != null )
			{
				picture.close();
			}
			if ( shutter != null )
			{
				shutter.release();
			}
			this.finish();
		}
		catch ( Exception e )
		{
			error( "closeApp", e );
		}
	}

	protected void enableKeyboard( boolean enable )
	{
		if ( !isTestRunning )
		{
			enableButton( R.id.btTest, enable );
		}

		enableButtonImage( R.id.btnPrint, enable );
		enableButtonImage( R.id.btnR, enable );
		enableButtonImage( R.id.btnRo, enable );
	}

	private static class mHandler extends Handler
	{
		private final WeakReference<EM4058> mActivity;

		public mHandler( EM4058 activity )
		{
			mActivity = new WeakReference<>( activity );
		}

		@Override
		public void handleMessage( @NonNull Message msg )
		{
			final EM4058 activity = mActivity.get();

			switch ( msg.what )
			{
				case EM4058BluetoothThread.Constants.MESSAGE_STATE_CHANGE:
					int state = msg.arg1;
					switch ( state )
					{
						case EM4058BluetoothThread.STATE_CONNECTED:
							activity.idle = true;
							activity.isConnected( true );
							activity.FIFO.add( Command.MEMORY_MAP() );
							activity.checkConnStart();
							activity.messageBox( R.string.connecting, COLOR_YELLOW, true );
							break;
						case EM4058BluetoothThread.STATE_CONNECTING:
							activity.isDisconnectedByUser = false;
							activity.enableManagerBar( false );
							activity.messageBox( R.string.connecting, COLOR_YELLOW, true );
							break;
						case EM4058BluetoothThread.STATE_FAIL:
							activity.isConnected( false );
							activity.enableManagerBar( true );
							if ( !activity.isDisconnectedByUser )
							{
								activity.createConnectionDialog();
								activity.isDisconnectedByUser = true;
							}
							activity.messageBox( R.string.disconnected, COLOR_BLACK, false );
							break;
						case EM4058BluetoothThread.STATE_NONE:
							activity.isConnected( false );
							activity.enableManagerBar( true );
							if ( !activity.isDisconnectedByUser )
							{
								activity.createConnectionDialog();
								activity.isDisconnectedByUser = true;
							}
							activity.messageBox( R.string.disconnected, COLOR_BLACK, false );
							break;
					}
					break;
				case EM4058BluetoothThread.Constants.MESSAGE_READ:
					activity.statusBlink();
					activity.timeoutCount = 0;
					activity.rxTimeOutStart();
					String cleanMsg = (String) msg.obj;
					cleanMsg = cleanMsg.replace( Command.SF, "" );
					cleanMsg = cleanMsg.replace( Command.EF, "" );
					activity.rx += cleanMsg;
					break;
			}
		}
	}

	private final mHandler handlerRX = new mHandler(this);

	int NUM_OF_PACKS = 8;
	int TEMP_PACKS = 8;
	int POINTER=0;
	@SuppressWarnings({"unused", "StatementWithEmptyBody"})
	private void processProtocol(String msg)
	{
		try
		{
			if ( cmdType == Command.MEMORY_MAP().getType() )
			{
				msg = cleanMsg( msg );
				int memoryMap = com.megabras.modbus.MUtils.hexToInt( msg );
				Command.setMemoryMap( memoryMap );
				FIFO.add( Command.MODEL() );
			}
			else if ( cmdType == Command.MODEL().getType() )
			{
				FIFO.add( Command.GET_DATE() );
				FIFO.add( Command.EM4058.GET_OPERATION_MODE() );
				FIFO.add( Command.EM4058.SHORT_STATUS() );
			}
			else if ( cmdType == Command.EM4058.SHORT_STATUS().getType() )
			{
				msg = cleanMsg( msg );
				String battery = msg.substring( 4, 8 );
				updateBatteryIcon( Integer.valueOf( battery, 16 ) );

				if ( dlgDetails != null && dlgDetails.isShowing() )
				{
					((TextView) dlgDetails.findViewById( R.id.lbl_battery )).setText( Integer.valueOf( battery, 16 ) + "%" );
				}

				String voltageHex = msg.substring(8,12);

				float voltageFloat = (float) MUtils.hexToInt(voltageHex)/10;
				String voltage  = voltageFloat + " V";
				((TextView)findViewById(R.id.lb_voltage))
						.setText(voltage);

				String status = msg.substring(0, 4);
				boolean[] bits = MUtils.hexToBitArray(status);

				if ( bits[0] ) // Running
				{
					isTestRunning = true;
					enableKeyboard( false );
					FIFO.add( Command.EM4058.TEST_NUMBER() );
				}
				else
				{
					if ( isTestRunning )
					{
						if ( bits[1] )
						{
							messageBox( R.string.check_pole_h, COLOR_RED, false );
							((TextView) findViewById( R.id.lb_resistance )).setText( "- - -" );
							((TextView) findViewById( R.id.lb_resistance_270Hz )).setText( "" );
							((TextView) findViewById( R.id.lb_resistance_570Hz )).setText( "" );
							((TextView) findViewById( R.id.lb_resistance_870Hz )).setText( "" );
							((TextView) findViewById( R.id.lb_resistance_1170Hz )).setText( "" );
							((TextView) findViewById( R.id.lb_resistance_1470Hz )).setText( "" );
						}
						if ( bits[2] )
						{
							messageBox( R.string.check_pole_s, COLOR_RED, false );
							((TextView) findViewById( R.id.lb_resistance )).setText( "- - -" );
							((TextView) findViewById( R.id.lb_resistance_270Hz )).setText( "" );
							((TextView) findViewById( R.id.lb_resistance_570Hz )).setText( "" );
							((TextView) findViewById( R.id.lb_resistance_870Hz )).setText( "" );
							((TextView) findViewById( R.id.lb_resistance_1170Hz )).setText( "" );
							((TextView) findViewById( R.id.lb_resistance_1470Hz )).setText( "" );
						}
						isTestRunning = false;
					}
					enableKeyboard( true );
				}
				if ( bits[8] && !bits[0] )
				{
					messageBox( R.string.earth_voltage_high, COLOR_RED, false );
					enableButton( R.id.btTest, false );
				}
				else
				{
					if ( !bits[1] && !bits[2] ) // NOT CHECK POLE
					{
						messageBox( R.string.ready, COLOR_GREEN, false );
					}
					enableButton( R.id.btTest, true );
				}
				if ( bits[12] )
				{
					FIFO.add( Command.EM4058.RESET_EXTERNAL() );
					FIFO.add( Command.EM4058.GET_OPERATION_MODE() );
				}
			}
			else if ( cmdType == Command.EM4058.START().getType() )
			{
				FIFO.add( Command.EM4058.TEST_NUMBER() );
			}
			else if ( cmdType == Command.EM4058.TEST_NUMBER().getType() )
			{
				messageBox( R.string.running, COLOR_RED, true );

				((TextView) findViewById( R.id.lb_voltage )).setText( "" );
				((TextView) findViewById( R.id.lb_resistance )).setText( R.string.wait );
				((TextView) findViewById( R.id.lb_resistance_270Hz )).setText( R.string.wait );
				((TextView) findViewById( R.id.lb_resistance_570Hz )).setText( R.string.wait );
				((TextView) findViewById( R.id.lb_resistance_870Hz )).setText( R.string.wait );
				((TextView) findViewById( R.id.lb_resistance_1170Hz )).setText( R.string.wait );
				((TextView) findViewById( R.id.lb_resistance_1470Hz )).setText( R.string.wait );

				int testNumber = Integer.valueOf( msg.substring( 6, 10 ), 16 );

				test.addNewMeasuredValues( testNumber );

				((TextView) findViewById( R.id.lb_test_number )).setText( testNumber + "" );
				FIFO.add( Command.EM4058.FULL_STATUS() );
			}
			else if ( cmdType == Command.EM4058.FULL_STATUS().getType() )
			{
				String    fullStatus = cleanMsg( msg );
				boolean[] bits       = MUtils.hexToBitArray( fullStatus.substring( 12, 16 ) );
				if ( bits[0] )
				{// Running
					isTestRunning = true;
					enableKeyboard( false );
					resultsParser( fullStatus );
					FIFO.add( Command.EM4058.FULL_STATUS() ); // Ask Full Status again, until the test is stopped
				}
				else
				{
					resultsParser( fullStatus );
					if ( !bits[1] && !bits[2] )
					{// Stopped and not check pole
						if ( isTestRunning )
						{
							FIFO.add( Command.MEMORY_POINTER() );
						}
					}
					else
					{
						if ( bits[1] )
							messageBox( R.string.check_pole_h, COLOR_RED, false );
						if ( bits[2] )
							messageBox( R.string.check_pole_s, COLOR_RED, false );
						if ( bits[1] && bits[2] )
							messageBox( R.string.check_pole_h_s, COLOR_RED, false );

						((TextView) findViewById( R.id.lb_voltage )).setText( "" );
						((TextView) findViewById( R.id.lb_resistance )).setText( "- - -" );
						((TextView) findViewById( R.id.lb_resistance_270Hz )).setText( "" );
						((TextView) findViewById( R.id.lb_resistance_570Hz )).setText( "" );
						((TextView) findViewById( R.id.lb_resistance_870Hz )).setText( "" );
						((TextView) findViewById( R.id.lb_resistance_1170Hz )).setText( "" );
						((TextView) findViewById( R.id.lb_resistance_1470Hz )).setText( "" );
						keyboardRunningTest( false );
					}
					isTestRunning = false;
				}
				if ( bits[12] )
				{
					FIFO.add( Command.EM4058.RESET_EXTERNAL() );
					FIFO.add( Command.EM4058.GET_OPERATION_MODE() );
				}
			}
			else if ( cmdType == Command.EM4058.GET_OPERATION_MODE().getType() )
			{
				messageBox( R.string.ready, COLOR_GREEN, false );
				enableKeyboard( true );
				enableManagerBar( true );

				msg = cleanMsg( msg );

				short WORD_SIZE    = 4;
				short POINTER_SIZE = 0;

				String MODE = msg.substring( POINTER_SIZE, POINTER_SIZE + WORD_SIZE );
				POINTER_SIZE += WORD_SIZE;

				String TEST_NUMBER = msg.substring( POINTER_SIZE, POINTER_SIZE + WORD_SIZE );
				POINTER_SIZE += WORD_SIZE;

				String REMOTE_CONTROL = msg.substring( POINTER_SIZE, POINTER_SIZE + WORD_SIZE );
				POINTER_SIZE += WORD_SIZE;

				String FREQUENCY = msg.substring( POINTER_SIZE, POINTER_SIZE + WORD_SIZE );
				POINTER_SIZE += WORD_SIZE;

				FREQUENCY = FREQUENCY.replace( "FF", "00" );

				int Fre = MUtils.hexToInt( FREQUENCY );

				test.setSelectedFrequency( Fre );

				((TextView) findViewById( R.id.lb_frequency ))
						.setText( Command.EM4058.getFrequencyValue( Fre ) );

				String DISTANCE = msg.substring( POINTER_SIZE, POINTER_SIZE + WORD_SIZE );

				DISTANCE = DISTANCE.replace( "FF", "00" );

				int Dis = MUtils.hexToInt( DISTANCE );

				String distance;

				if ( Dis == 0 )
				{
					distance = "Rx";
				}
				else
				{
					distance = Dis + " m";
				}

				((TextView) findViewById( R.id.lb_test_number )).setText( "- - -" );
				((TextView) findViewById( R.id.lb_voltage )).setText( "" );
				((TextView) findViewById( R.id.lb_resistance )).setText( "- - -" );
				((TextView) findViewById( R.id.lb_resistance_270Hz )).setText( "" );
				((TextView) findViewById( R.id.lb_resistance_570Hz )).setText( "" );
				((TextView) findViewById( R.id.lb_resistance_870Hz )).setText( "" );
				((TextView) findViewById( R.id.lb_resistance_1170Hz )).setText( "" );
				((TextView) findViewById( R.id.lb_resistance_1470Hz )).setText( "" );

				boolean[] bits = MUtils.hexToBitArray( MODE );

				if ( bits[0] )
				{
					((TextView) findViewById( R.id.lb_resistance ))
							.setCompoundDrawablesWithIntrinsicBounds( R.drawable.ic_resistance, 0, 0, 0 );
					changeButtonImage( R.id.btnR, R.drawable.bt_r_on, true );
					changeButtonImage( R.id.btnRo, R.drawable.bt_ro_off, true );
					findViewById( R.id.lb_resistance_270Hz ).setVisibility( View.VISIBLE );
					findViewById( R.id.lb_resistance_570Hz ).setVisibility( View.VISIBLE );
					findViewById( R.id.lb_resistance_870Hz ).setVisibility( View.VISIBLE );
					findViewById( R.id.lb_resistance_1170Hz ).setVisibility( View.VISIBLE );
					findViewById( R.id.lb_resistance_1470Hz ).setVisibility( View.VISIBLE );
					findViewById( R.id.lb_distance ).setVisibility( View.GONE );
					findViewById( R.id.lb_frequency ).setVisibility( View.VISIBLE );
				}
				else
				{
					((TextView) findViewById( R.id.lb_resistance ))
							.setCompoundDrawablesWithIntrinsicBounds( R.drawable.ic_resistance, 0, 0, 0 );
					changeButtonImage( R.id.btnR, R.drawable.bt_r_on, true );
					changeButtonImage( R.id.btnRo, R.drawable.bt_ro_off, true );
					findViewById( R.id.lb_resistance_270Hz ).setVisibility( View.INVISIBLE );
					findViewById( R.id.lb_resistance_570Hz ).setVisibility( View.INVISIBLE );
					findViewById( R.id.lb_resistance_870Hz ).setVisibility( View.INVISIBLE );
					findViewById( R.id.lb_resistance_1170Hz ).setVisibility( View.INVISIBLE );
					findViewById( R.id.lb_resistance_1470Hz ).setVisibility( View.INVISIBLE );
					findViewById( R.id.lb_distance ).setVisibility( View.GONE );
					findViewById( R.id.lb_frequency ).setVisibility( View.VISIBLE );
				}

				if ( bits[1] )
				{ //Soil Resistivity; 4-Pole
					if ( Dis == 0 ) //Rx
					{
						((TextView) findViewById( R.id.lb_resistance )).setCompoundDrawablesWithIntrinsicBounds( R.drawable.ic_resistance, 0, 0, 0 );
					}
					else
					{
						((TextView) findViewById( R.id.lb_resistance ))
								.setCompoundDrawablesWithIntrinsicBounds( R.drawable.ic_rho, 0, 0, 0 );
					}

					changeButtonImage( R.id.btnR, R.drawable.bt_r_off, true );
					changeButtonImage( R.id.btnRo, R.drawable.bt_ro_on, true );

					findViewById( R.id.lb_resistance_270Hz ).setVisibility( View.INVISIBLE );
					findViewById( R.id.lb_resistance_570Hz ).setVisibility( View.INVISIBLE );
					findViewById( R.id.lb_resistance_870Hz ).setVisibility( View.INVISIBLE );
					findViewById( R.id.lb_resistance_1170Hz ).setVisibility( View.INVISIBLE );
					findViewById( R.id.lb_resistance_1470Hz ).setVisibility( View.INVISIBLE );

					findViewById( R.id.lb_distance ).setVisibility( View.VISIBLE );
					findViewById( R.id.lb_frequency ).setVisibility( View.GONE );

					((TextView) findViewById( R.id.lb_distance )).setText( distance );
				}
			}
			else if ( cmdType == Command.EM4058.WRITE_MODE( "", "" ).getType() )
			{
				FIFO.add( Command.EM4058.GET_OPERATION_MODE() );
			}
			else if ( cmdType == Command.EM4058.RESET_EXTERNAL().getType() )
			{
			}
			else if ( cmdType == Command.MEMORY_POINTER().getType() )
			{
				NUM_OF_PACKS = 8;
				TEMP_PACKS = 8;
				String pointerString = msg.substring( 6, 10 );
				POINTER = Integer.valueOf( pointerString, 16 ) - 1;
				FIFO.add( Command.GET_MEM_PACK( (POINTER - (NUM_OF_PACKS - TEMP_PACKS)) ) );
				TEMP_PACKS--;
			}
			else if ( cmdType == Command.GET_MEM_PACK( 0 ).getType() )
			{
				msg = cleanMsg( msg );
				if ( TEMP_PACKS >= 0 && !msg.startsWith( "CA" ) )
				{
					FIFO.add( Command.GET_MEM_PACK( (POINTER - (NUM_OF_PACKS - TEMP_PACKS)) ) );
					TEMP_PACKS--;
				}
				else
				{
					enableKeyboard( true );
					messageBox( R.string.finished, COLOR_GREEN, false );
					keyboardRunningTest( false );
				}

				if ( msg.startsWith( "CA" ) )
				{
					int testNumber = Integer.valueOf( msg.substring( 2, 6 ), 16 );

					byte mm = Integer.valueOf( msg.substring( 6, 8 ), 16 ).byteValue();
					byte hh = Integer.valueOf( msg.substring( 8, 10 ), 16 ).byteValue();
					byte DD = Integer.valueOf( msg.substring( 10, 12 ), 16 ).byteValue();
					byte MM = Integer.valueOf( msg.substring( 12, 14 ), 16 ).byteValue();
					byte YY = Integer.valueOf( msg.substring( 14, 16 ), 16 ).byteValue();

					String date = String.format( Locale.getDefault(), "%02d", DD ) + "/" +
							String.format( Locale.getDefault(), "%02d", MM ) + "/" +
							String.format( Locale.getDefault(), "%02d", YY ) + " " +
							String.format( Locale.getDefault(), "%02d", hh ) + ":" +
							String.format( Locale.getDefault(), "%02d", mm );

					test.getLastMeasuredValues().setTestDate( date );

					test.getLastMeasuredValues().setFrequency(
							Command.EM4058.getFrequencyValue( test.getSelectedFrequency() )
					);

					adapter.add( test.getLastMeasuredValues() );

					if ( !test.getCurrentObject().equals( "" ) )
					{
						test.addTestResult( test.getLastMeasuredValues() );
						enableButtonImage( R.id.btn_sound, true );
					}
				}

				//4-Pole
				if ( msg.startsWith( "CC" ) )
				{
					String distanceHex = msg.substring( 2, 4 );
					int    distance    = Integer.valueOf( distanceHex, 16 );

					String voltageHex = msg.substring( 4, 8 );

					float  voltageFloat = (float) MUtils.hexToInt( voltageHex ) / 10;
					String voltage      = voltageFloat + " V";


					String resistivityHex = msg.substring( 8, 16 );
					float  resistivity    = Float.valueOf( MUtils.hexToFloat( resistivityHex ) );
					String resistivityFormatted;
					if ( distance == 0 )
					{
						resistivityFormatted =
								Command.EM4058.formatResistanceResolution( resistivity );
						test.getLastMeasuredValues().setDistance( "Rx" );
					}
					else
					{
						resistivityFormatted =
								Command.EM4058.formatResistivityResolution( resistivity );
						test.getLastMeasuredValues().setDistance( distance + " m" );
					}

					test.getLastMeasuredValues().setTestType( getString( R.string.soil_resistivity ) );

					test.getLastMeasuredValues().setVoltage( voltage );
					test.getLastMeasuredValues().setResult( resistivityFormatted );

					((TextView) findViewById( R.id.lb_voltage )).setText( voltage );
					((TextView) findViewById( R.id.lb_resistance )).setText( resistivityFormatted );
				}

				//3-Pole
				if ( msg.startsWith( "CD" ) )
				{
					String frequencyHex = msg.substring( 2, 4 );
					String frequency = Command.EM4058.getFrequencyValue(
							Integer.valueOf( frequencyHex, 16 ) );

					String voltageHex = msg.substring( 4, 8 );

					float  voltageFloat = (float) MUtils.hexToInt( voltageHex ) / 10;
					String voltage      = voltageFloat + " V";

					String resistanceHex      = msg.substring( 8, 16 );
					float  resistance         = Float.valueOf( MUtils.hexToFloat( resistanceHex ) );
					String resistanceFormated = Command.EM4058.formatResistanceResolution( resistance );

					((TextView) findViewById( R.id.lb_voltage )).setText( voltage );

					test.getLastMeasuredValues().setTestType( getString( R.string.earth_resistance ) );

					test.getLastMeasuredValues().setVoltage( voltage );

					switch ( Integer.valueOf( frequencyHex, 16 ) )
					{
						case 0:
							((TextView) findViewById( R.id.lb_resistance_270Hz )).setText( resistanceFormated );
							test.getLastMeasuredValues().setResult270Hz( resistanceFormated );
							break;
						case 1:
							((TextView) findViewById( R.id.lb_resistance_570Hz )).setText( resistanceFormated );
							test.getLastMeasuredValues().setResult570Hz( resistanceFormated );
							break;
						case 2:
							((TextView) findViewById( R.id.lb_resistance_870Hz )).setText( resistanceFormated );
							test.getLastMeasuredValues().setResult870Hz( resistanceFormated );
							break;
						case 3:
							((TextView) findViewById( R.id.lb_resistance_1170Hz )).setText( resistanceFormated );
							test.getLastMeasuredValues().setResult1170Hz( resistanceFormated );
							break;
						case 4:
							((TextView) findViewById( R.id.lb_resistance_1470Hz )).setText( resistanceFormated );
							test.getLastMeasuredValues().setResult1470Hz( resistanceFormated );
							break;
						case 5:
							((TextView) findViewById( R.id.lb_resistance )).setText( resistanceFormated );
							test.getLastMeasuredValues().setResult( resistanceFormated );
							break;
					}

					if ( test.getSelectedFrequency() != 5 )
					{
						((TextView) findViewById( R.id.lb_resistance )).setText( resistanceFormated );
						test.getLastMeasuredValues().setResult( resistanceFormated );
					}
				}
			}
			else if ( cmdType == Command.GET_DATE().getType() )
			{
				SimpleDateFormat dateFormatter = new SimpleDateFormat( "dd/MM/yy HH:mm:ss", Locale.getDefault() );
				TimeZone         utc           = TimeZone.getTimeZone( "UTC" );
				dateFormatter.setTimeZone( utc );
				long       devCurrentTime    = Integer.valueOf( msg.substring( 6, 14 ), 16 );

				if ( dlgDetails != null && dlgDetails.isShowing() )
				{
					((TextView) dlgDetails.findViewById( R.id.lbl_date )).setText( dateFormatter.format( new Date( devCurrentTime * 1000L ) ) );
				}
			}
			else if ( cmdType == Command.SET_DATE().getType() )
			{
			}
			else if ( cmdType == Command.FREE_MEMORY().getType() )
			{
				int    maxMemSize = 4095;
				String _point     = msg.substring( 6, 10 );
				int    point      = Integer.valueOf( _point, 16 ).shortValue();
				int    usedMem    = (point * 100) / maxMemSize;
				int    left       = (point * 100) % maxMemSize;
				left = (left > 0) ? 1 : 0;
				int freeMem = 100 - usedMem - left;

				if ( dlgDetails != null && dlgDetails.isShowing() )
				{
					((TextView) dlgDetails.findViewById( R.id.lbl_mem )).setText( freeMem + "%" );
				}
			}
			else if ( cmdType == Command.ERASE_MEMORY().getType() )
			{
			}
			else if ( cmdType == Command.EM4058.STOP().getType() )
			{
				if ( Command.EM4058.STOP().checkResponse( msg ) )
				{
					isTestRunning = false;
					testStopped = false;
					enableKeyboard( true );
					keyboardRunningTest( isTestRunning );
					messageBox( R.string.test_cancelled, COLOR_RED, false );
					((TextView) findViewById( R.id.lb_voltage )).setText( "" );
					((TextView) findViewById( R.id.lb_resistance )).setText( "- - -" );
					((TextView) findViewById( R.id.lb_resistance_270Hz )).setText( "" );
					((TextView) findViewById( R.id.lb_resistance_570Hz )).setText( "" );
					((TextView) findViewById( R.id.lb_resistance_870Hz )).setText( "" );
					((TextView) findViewById( R.id.lb_resistance_1170Hz )).setText( "" );
					((TextView) findViewById( R.id.lb_resistance_1470Hz )).setText( "" );
				}
			}
			else
			{
				enableKeyboard( true );
			}
			if ( !FIFO.isEmpty() )
			{
				FIFO.remove();
			}
			idle = true;
			rx = "";
		} catch (Exception e){
			Log.e(TAG,e.getMessage()+"");
			for (StackTraceElement ste : e.getStackTrace()){
				Log.e(TAG,ste.toString());
			}

			error("processProtocol", e);
		}
	}

	private String cleanMsg(String msg){
		String cleanMsg;
		try{
			cleanMsg = msg.substring(6, msg.length()-2);
		} catch (Exception e){
			cleanMsg = "";
		}
        return cleanMsg;
    }

	private void resultsParser(String msg) {
		try{
			short WORD_SIZE = 4;//In this case, 4 chars
			short POINTER_SIZE = 0;
			short RESULT_SIZE  = (short) (2*WORD_SIZE);
			short F_SIZE       = WORD_SIZE;
			short STATUS_SIZE  = WORD_SIZE;
			short BATERY_SIZE  = WORD_SIZE;
			short VOLTAGE      = WORD_SIZE;
			short F_270        = (short) (2 * WORD_SIZE);
			short F_570        = (short) (2 * WORD_SIZE);
			short F_870        = (short) (2 * WORD_SIZE);
			short F_1170       = (short) (2 * WORD_SIZE);
			short F_1470       = (short) (2 * WORD_SIZE);

			if(msg.length()<(RESULT_SIZE+F_SIZE+STATUS_SIZE+BATERY_SIZE+VOLTAGE+F_270+F_570+F_870+F_1170+F_1470)){
				return;
			}

			POINTER_SIZE += RESULT_SIZE;
			POINTER_SIZE += F_SIZE;
			POINTER_SIZE += STATUS_SIZE;
			POINTER_SIZE += BATERY_SIZE;

			String voltageHex = msg.substring(POINTER_SIZE, POINTER_SIZE + VOLTAGE);
			POINTER_SIZE += VOLTAGE;

			float voltageFloat = (float) MUtils.hexToInt(voltageHex)/10;

			String voltage  = voltageFloat + " V";

			((TextView)findViewById(R.id.lb_voltage))
					.setText(voltage);
		} catch (Exception e) {
			error("TestRunningParser", e);
		}
	}

	private void connecting()
	{
		timeoutCount = 0;
		idle = true;
		enableKeyboard( false );
		isTestRunning = false;
		testStopped = false;
		keyboardRunningTest( false );

		BluetoothAdapter adaptador = BluetoothAdapter.getDefaultAdapter();
		adaptador.cancelDiscovery();
		BluetoothDevice device = adaptador.getRemoteDevice( mac );

		bluetoothThread = new EM4058BluetoothThread( handlerRX );
		bluetoothThread.connect( device, false );
	}

	public void disconnect()
	{
		try
		{
			if ( bluetoothThread != null )
			{
				bluetoothThread.stop();
			}
		}
		catch ( Exception e )
		{
			error( "Disconnect", e );
		}
	}

	private void updateBatteryIcon(int charge)
	{
		ImageView batteryIcon = findViewById(R.id.ic_battery);

		if (charge > 99) {
			batteryIcon.setImageResource(R.drawable.bat_100);
		} else if (charge > 80) {
			batteryIcon.setImageResource(R.drawable.bat_90);
		} else if (charge > 70) {
			batteryIcon.setImageResource(R.drawable.bat_80);
		} else if (charge > 60) {
			batteryIcon.setImageResource(R.drawable.bat_70);
		} else if (charge > 50) {
			batteryIcon.setImageResource(R.drawable.bat_60);
		} else if (charge > 40) {
			batteryIcon.setImageResource(R.drawable.bat_50);
		} else if (charge > 30) {
			batteryIcon.setImageResource(R.drawable.bat_40);
		} else if (charge > 20) {
			batteryIcon.setImageResource(R.drawable.bat_30);
		} else if (charge > 10) {
			batteryIcon.setImageResource(R.drawable.bat_20);
		} else if (charge > 5) {
			batteryIcon.setImageResource(R.drawable.bat_10);
		} else {
			batteryIcon.setImageResource(R.drawable.bat_0);
		}
	}

	public void messageBox( int msg, int color, boolean progressBar )
	{
		View box = findViewById( R.id.ct_user_message );
		box.setBackground( ResourcesCompat.getDrawable( getResources(), color, null ) );
		TextView lbMsg = findViewById( R.id.lb_user_message );
		lbMsg.setText( getResources().getString( msg ) );
		ProgressBar pBar = findViewById( R.id.pBar );
		if ( progressBar )
		{
			pBar.setVisibility( View.VISIBLE );
		}
		else
		{
			pBar.setVisibility( View.GONE );
		}
	}

	public void setModeResistance(View view) {
		createSettingsDialog(true);
	}

	public void setModeResistivity(View view) {
		createSettingsDialog(false);
	}

	public void devPrintTest( View view )
	{
		enableKeyboard( false );
		FIFO.add( Command.EM4058.PRINTER() );
	}

	public void devStartTest(View view)
	{
		try
		{
			if(!isTestRunning)
			{
				isTestRunning = true;
				enableKeyboard(false);
				keyboardRunningTest(isTestRunning);
				FIFO.add( Command.EM4058.START() );
			}
		}
		catch (Exception e)
		{
			error("devStartTest(View view)", e);
		}
	}

	public void devStopTest(View view){
		try{
			if(isTestRunning){
				testStopped = true;
			}
		} catch (Exception e) {
			error("devStopTest(View view)", e);
		}
	}

	public void keyboardRunningTest( boolean running )
	{
		if ( running )
		{
			if ( findViewById( R.id.btTest ) != null )
				findViewById( R.id.btTest ).setVisibility( View.GONE );
			if ( findViewById( R.id.btnStop ) != null )
				findViewById( R.id.btnStop ).setVisibility( View.VISIBLE );
		}
		else
		{
			if ( findViewById( R.id.btTest ) != null )
				findViewById( R.id.btTest ).setVisibility( View.VISIBLE );
			if ( findViewById( R.id.btnStop ) != null )
				findViewById( R.id.btnStop ).setVisibility( View.GONE );
		}
	}

	private void rxTimeOutStart() {
		if(h2!=null){
			h2.removeCallbacks(rxTimeOut);
			h2.postDelayed(rxTimeOut, 50);
		}
	}
	
	private void checkConnStart() {		
		h2.removeCallbacks(checkConnection);
		h2.postDelayed(checkConnection, PING_TIME);
	}

	private void writeErrorLog(String msg){
		try {			            
			String folder = Environment.getExternalStorageDirectory().toString();		
			File file = new File(folder + "/" + context.getResources().getString(R.string.company) + "/" + "error.log");
			
			if(file.exists() && file.length() > 1000000){
				file.delete();
			}
			
            if (!file.exists()) {
                file.createNewFile();
            }

            FileWriter f;            
	        f = new FileWriter(file.toString(), true);
	        f.write(msg);	        
	        f.flush();
	        f.close();
		} catch (Exception ignored){}
	}

	public void error(String method, Exception error){
		try {			
			String msg = "";
			SimpleDateFormat dateFormatter = new SimpleDateFormat("dd/MM/yy HH:mm:ss.SSS", Locale.getDefault());
			String company = getResources().getString(R.string.company);
			String version = getPackageManager().getPackageInfo(getPackageName(), 0).versionName;
			String date = dateFormatter.format(new Date());			
			StackTraceElement[] e = error.getStackTrace();
			
			msg += "DATE\t: \t" + date + "\r\n";
			msg += "BRAND\t: \t" + company + "\r\n";
			msg += "VERSION\t: \t" + version + "\r\n";
			msg += "CLASS\t: \t" + this.getClass().getName() + "\r\n"; 
			msg += "METHOD\t: \t" + method + "\r\n";
			msg += "CAUSE\t: \t" + error.toString() + "\r\n";			
			msg += "STACK: \r\n";

			for (StackTraceElement anE : e)
			{
				msg += anE.toString() + "\r\n";
			}
			msg += "\r\n";
			
			writeErrorLog(msg);
		} catch (Exception e){
			Log.e("error log", e.toString());			
		}		
	}
}
