package com.megabras.bluelogg.em4058;

import android.annotation.SuppressLint;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.LinearLayout;
import android.widget.TableLayout;
import android.widget.TextView;

import com.megabras.bluelogg.R;

import java.util.ArrayList;

public class EM4058TableBaseAdapter extends BaseAdapter
{
	private LayoutInflater
			inflater;

	private ArrayList<EM4058test.EM4058values>
			values;

	EM4058TableBaseAdapter( Context context )
	{
		values = new ArrayList<>();
		inflater = LayoutInflater.from( context );
	}

	public long getItemId( int position )
	{
		return 0;
	}

	public int getCount()
	{
		return values.size();
	}

	public EM4058test.EM4058values getItem( int position )
	{
		return values.get( position );
	}

	void addAll( ArrayList<EM4058test.EM4058values> values )
	{
		this.values = values;
		notifyDataSetChanged();
	}

	public void clear()
	{
		this.values.clear();
		notifyDataSetChanged();
	}

	public void add( EM4058test.EM4058values newValue )
	{
		values.add( newValue );
		notifyDataSetChanged();
	}

	public void repaint()
	{
		notifyDataSetChanged();
	}

	@SuppressLint("SetTextI18n")
	public View getView( int position, View view, ViewGroup parent )
	{
		View vi = view;
		ViewHolder holder;

		if ( vi == null )
		{
			vi = inflater.inflate( R.layout.em4058_table_item, parent, false );

			holder = new ViewHolder();
			holder.img_audio = vi.findViewById( R.id.img_audio );
			holder.table_main_container = vi.findViewById( R.id.table_main_container );
			holder.table_scan_results = vi.findViewById( R.id.table_scan_results );
			holder.table_item_measure_unity = vi.findViewById( R.id.em4058_table_item_measure_unity );
			holder.table_lb_test_number = vi.findViewById( R.id.table_lb_test_number );
			holder.table_lb_test_date = vi.findViewById( R.id.table_lb_test_date );
			holder.table_lb_test_type = vi.findViewById( R.id.table_lb_test_type );
			holder.table_lb_result = vi.findViewById( R.id.table_lb_result );
			holder.table_lb_frequency = vi.findViewById( R.id.table_lb_frequency );
			holder.table_lb_distance_label = vi.findViewById( R.id.table_lb_distance_label );
			holder.table_lb_distance = vi.findViewById( R.id.table_lb_distance );
			holder.table_lb_voltage = vi.findViewById( R.id.table_lb_voltage );
			holder.table_lb_270Hz = vi.findViewById( R.id.table_lb_270Hz );
			holder.table_lb_570Hz = vi.findViewById( R.id.table_lb_570Hz );
			holder.table_lb_870Hz = vi.findViewById( R.id.table_lb_870Hz );
			holder.table_lb_1170Hz = vi.findViewById( R.id.table_lb_1170Hz );
			holder.table_lb_1470Hz = vi.findViewById( R.id.table_lb_1470Hz );

			vi.setTag( holder );
		}
		else
		{
			holder = (ViewHolder) vi.getTag();
		}

		if ( !values.get( position ).getAudioPath().equals( "" ) )
		{
			holder.img_audio.setVisibility( View.VISIBLE );
		}
		else
		{
			holder.img_audio.setVisibility( View.INVISIBLE );
		}

		if ( values.get( position ).getFrequency().equals( "SCAN" ) )
		{
			holder.table_scan_results.setVisibility( View.VISIBLE );
		}
		else
		{
			holder.table_scan_results.setVisibility( View.GONE );
		}

		if ( values.get( position ).getTestType().contains( "4" ) && !values.get( position ).getDistance().contains( "Rx" ) )
		{
			holder.table_item_measure_unity.setText( EM4058.RHO_SYMBOL + "=" );
		}
		else
		{
			holder.table_item_measure_unity.setText( "R=" );
		}

		holder.table_lb_test_number.setText( values.get( position ).getTestNumber() + " " );
		holder.table_lb_test_date.setText( values.get( position ).getTestDate() );
		holder.table_lb_test_type.setText( values.get( position ).getTestType() );
		holder.table_lb_result.setText( values.get( position ).getResult() );
		holder.table_lb_frequency.setText( values.get( position ).getFrequency() );

		if ( !values.get( position ).getDistance().equals( "" ) )
		{
			holder.table_lb_distance.setVisibility( View.VISIBLE );
			holder.table_lb_distance_label.setVisibility( View.VISIBLE );
			holder.table_lb_distance.setText( values.get( position ).getDistance() );
		}
		else
		{
			holder.table_lb_distance.setVisibility( View.INVISIBLE );
			holder.table_lb_distance_label.setVisibility( View.INVISIBLE );
		}
		holder.table_lb_voltage.setText( values.get( position ).getVoltage() );
		holder.table_lb_270Hz.setText( values.get( position ).getResult270Hz() );
		holder.table_lb_570Hz.setText( values.get( position ).getResult570Hz() );
		holder.table_lb_870Hz.setText( values.get( position ).getResult870Hz() );
		holder.table_lb_1170Hz.setText( values.get( position ).getResult1170Hz() );
		holder.table_lb_1470Hz.setText( values.get( position ).getResult1470Hz() );

        return vi;
    }

	static class ViewHolder
	{
		ImageView img_audio;
		LinearLayout table_main_container;
		TableLayout table_scan_results;
		TextView table_item_measure_unity;
		TextView table_lb_test_number;
		TextView table_lb_test_date;
		TextView table_lb_test_type;
		TextView table_lb_result;
		TextView table_lb_frequency;
		TextView table_lb_distance_label;
		TextView table_lb_distance;
		TextView table_lb_voltage;
		TextView table_lb_270Hz;
		TextView table_lb_570Hz;
		TextView table_lb_870Hz;
		TextView table_lb_1170Hz;
		TextView table_lb_1470Hz;
	}
}
