package com.megabras.bluelogg.extended;

import android.content.Context;
import android.hardware.Camera;
import android.util.AttributeSet;
import android.util.Log;
import android.view.SurfaceHolder;
import android.view.SurfaceView;

import java.io.IOException;

public class CameraPreview extends SurfaceView implements SurfaceHolder.Callback
{
    private static final String TAG = "DEBBUG";
	private SurfaceHolder mHolder;
    private Camera mCamera;
    
    
    public CameraPreview(Context context) {
        super(context);
    }
    
    
    public CameraPreview(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    
    @SuppressWarnings("deprecation")
	public CameraPreview(Context context, Camera camera) {
        super(context);
        mCamera = camera;
        mHolder = getHolder();
        mHolder.addCallback(this);        
        mHolder.setType(SurfaceHolder.SURFACE_TYPE_PUSH_BUFFERS);
    }

    
    public void surfaceCreated(SurfaceHolder holder) {
        try {
            mCamera.setPreviewDisplay(holder);
            mCamera.startPreview();
        } catch (IOException e) {
            Log.d(TAG, "Error setting camera preview: " + e.getMessage());
        }
    }

    
    public void surfaceDestroyed(SurfaceHolder holder) {
    	mCamera.stopPreview();
        mCamera.release();
    }


    public void surfaceChanged( SurfaceHolder holder, int format, int w, int h )
    {
        if ( mHolder.getSurface() == null )
        {
            return;
        }

        try
        {
            mCamera.stopPreview();
        }
        catch ( Exception e )
        {
            Log.d( TAG, "Error stoping camera preview: " + e.getMessage() );
        }

        try
        {
            mCamera.setPreviewDisplay( mHolder );
            mCamera.startPreview();
        }
        catch ( Exception e )
        {
            Log.d( TAG, "Error starting camera preview: " + e.getMessage() );
        }
    }
    
    
}
