package com.megabras.bluelogg.md10kvx;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.Dialog;
import android.content.DialogInterface;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.view.View;
import android.view.ViewGroup;
import android.view.Window;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemSelectedListener;
import android.widget.ArrayAdapter;
import android.widget.Button;
import android.widget.FrameLayout;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.ProgressBar;
import android.widget.RelativeLayout;
import android.widget.Spinner;
import android.widget.Switch;
import android.widget.TextView;

import com.megabras.bluelogg.Command;
import com.megabras.bluelogg.extended.FileDetails;
import com.megabras.bluelogg.R;

import java.util.List;

public class MD10KVxUI
{
	private Activity
			activity;

	private Display
			display;

	@SuppressWarnings("unused")
	private final String
			TAG = "MD10KVxUI";

	private List<FileDetails>
			recorded;

	private RecordsBaseAdapter
			adapter;

	static final int
			COLOR_BLACK = R.drawable.chamfer_small_black,
			COLOR_YELLOW = R.drawable.chamfer_small_yellow,
			COLOR_GREEN = R.drawable.chamfer_small_green,
			COLOR_RED = R.drawable.chamfer_small_red;

	MD10KVxUI( Activity activity )
	{
		this.activity = activity;
		display = new Display( activity );
	}

	public void battery( int charge )
	{
		ImageView batteryIcon = activity.findViewById( R.id.ic_battery );
		if ( charge > 99 )
		{
			batteryIcon.setImageResource( R.drawable.bat_100 );
		}
		else if ( charge > 80 )
		{
			batteryIcon.setImageResource( R.drawable.bat_90 );
		}
		else if ( charge > 70 )
		{
			batteryIcon.setImageResource( R.drawable.bat_80 );
		}
		else if ( charge > 60 )
		{
			batteryIcon.setImageResource( R.drawable.bat_70 );
		}
		else if ( charge > 50 )
		{
			batteryIcon.setImageResource( R.drawable.bat_60 );
		}
		else if ( charge > 40 )
		{
			batteryIcon.setImageResource( R.drawable.bat_50 );
		}
		else if ( charge > 30 )
		{
			batteryIcon.setImageResource( R.drawable.bat_40 );
		}
		else if ( charge > 20 )
		{
			batteryIcon.setImageResource( R.drawable.bat_30 );
		}
		else if ( charge > 10 )
		{
			batteryIcon.setImageResource( R.drawable.bat_20 );
		}
		else if ( charge > 5 )
		{
			batteryIcon.setImageResource( R.drawable.bat_10 );
		}
		else
		{
			batteryIcon.setImageResource( R.drawable.bat_0 );
		}
	}

	void messageBox( String msg, int color, boolean progressBar )
	{
		activity.findViewById( R.id.ct_user_message ).setBackground( activity.getResources().getDrawable( color ) );
		TextView lbMsg = activity.findViewById( R.id.lb_user_message );
		lbMsg.setText( msg );
		ProgressBar pBar = activity.findViewById( R.id.pBar );
		if ( progressBar )
		{
			pBar.setVisibility( View.VISIBLE );
		}
		else
		{
			pBar.setVisibility( View.GONE );
		}
	}

	void messageBox( int msg, int color, boolean progressBar )
	{
		activity.findViewById( R.id.ct_user_message ).setBackground( activity.getResources().getDrawable( color ) );
		TextView lbMsg = activity.findViewById( R.id.lb_user_message );
		lbMsg.setText( activity.getResources().getString( msg ) );
		ProgressBar pBar = activity.findViewById( R.id.pBar );
		if ( progressBar )
		{
			pBar.setVisibility( View.VISIBLE );
		}
		else
		{
			pBar.setVisibility( View.GONE );
		}
	}

//	@SuppressLint("ClickableViewAccessibility")
//	void confirmExit( final MD10KVx parent )
//	{
//		final FrameLayout overlay = activity.findViewById(R.id.md10kvx_overlay);
//		final View inflatedView = View.inflate(activity, R.layout.md10kvx_fgr_msg, null);
//
//		overlay.removeAllViews();
//		overlay.addView(inflatedView);
//		overlay.setVisibility(View.VISIBLE);
//
//		//This is to prevent the ontouch propagate to others views
//		RelativeLayout overlayBase = inflatedView.findViewById(R.id.overlay_base);
//		overlayBase.requestDisallowInterceptTouchEvent(true);
//		overlayBase.setOnTouchListener( ( v, event ) -> true );
//
//		TextView title = inflatedView.findViewById(R.id.tx_title);
//		title.setText(activity.getResources().getString(R.string.md_close_app));
//
//		TextView message = inflatedView.findViewById(R.id.tx_message);
//		message.setText(activity.getResources().getString(R.string.md_close_app_confirmation));
//
//		Button btClose = inflatedView.findViewById(R.id.bt_confirm);
//		btClose.setOnClickListener( v -> parent.finish() );
//
//		Button btCancel = inflatedView.findViewById(R.id.bt_cancel);
//		btCancel.setOnClickListener( v -> overlay.removeAllViews() );
//	}

	@SuppressLint("ClickableViewAccessibility")
	void confirmExit( final MD10KVx parent )
	{

		final Dialog dialog = new Dialog( activity );
		dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dialog.setContentView( R.layout.dialog_yes_no );
		dialog.setCanceledOnTouchOutside( false );
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().getAttributes().width = android.view.ViewGroup.LayoutParams.WRAP_CONTENT;
			dialog.getWindow().getAttributes().height = android.view.ViewGroup.LayoutParams.WRAP_CONTENT;
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}

		((TextView) dialog.findViewById( R.id.dlg_title )).setText( R.string.md_close_app );
		((ImageView) dialog.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_warning );
		((TextView) dialog.findViewById( R.id.message )).setText( R.string.md_close_app_confirmation );

		ImageButton btnClose = dialog.findViewById( R.id.btn_close_dlg );
		if ( btnClose != null )
		{
			btnClose.setOnClickListener( l -> dialog.dismiss() );
		}

		dialog.findViewById( R.id.btn_no ).setOnClickListener( l -> dialog.dismiss() );
		dialog.findViewById( R.id.btn_yes ).setOnClickListener( v1 ->
		{
			dialog.dismiss();
			parent.finish();
		} );

		// OnBackPressed
		dialog.setOnCancelListener( DialogInterface::dismiss );

		dialog.show();
	}

//	@SuppressLint("ClickableViewAccessibility")
//	void openManager( final MD10KVx parent, final MD10KVxTest test, List<FileDetails> values )
//	{
//		final FrameLayout overlay = activity.findViewById(R.id.md10kvx_overlay);
//		final View inflatedView = View.inflate(activity, R.layout.md10kvx_fgr_manager, null);
//
//		overlay.removeAllViews();
//		overlay.addView(inflatedView);
//		overlay.setVisibility(View.VISIBLE);
//
//		//This is to prevent the ontouch propagate to others views
//		RelativeLayout overlayBase = inflatedView.findViewById(R.id.overlay_base);
//		overlayBase.requestDisallowInterceptTouchEvent(true);
//		overlayBase.setOnTouchListener( ( v, event ) -> true );
//
//		TextView title = inflatedView.findViewById(R.id.tx_title);
//		title.setText(activity.getResources().getString(R.string.md_saved_tests));
//
//		final ListView list = inflatedView.findViewById(R.id.listview);
//
//		recorded = values;
//		adapter = new RecordsBaseAdapter(parent, recorded);
//
//		list.setAdapter(adapter);
//
//		list.setOnItemClickListener( ( par, view, position, id ) ->
//		{
//			String fileName = adapter.getItem( position ).FILENAME;
//			parent.loadResults( fileName );
//			overlay.removeAllViews();
//		} );
//
//		final Button btDeleteSelected = inflatedView.findViewById(R.id.bt_delete_selected);
//		btDeleteSelected.setVisibility(View.GONE);
//
//		final Button btShowButtonDelete = inflatedView.findViewById(R.id.bt_confirm);
//		btShowButtonDelete.setOnClickListener( v ->
//		{
//			try
//			{
//				if ( recorded == null || recorded.isEmpty() )
//				{
//					return;
//				}
//				adapter.enableSelection( true );
//				btShowButtonDelete.setVisibility( View.GONE );
//				btDeleteSelected.setVisibility( View.VISIBLE );
//			}
//			catch ( Exception ignored )
//			{
//			}
//		} );
//
//		btDeleteSelected.setOnClickListener( v ->
//		{
//			if ( !adapter.hasItemChecked() )
//			{
//				return;
//			}
//
//			int len = adapter.getCount();
//			for ( int i = 0; i < len; i++ )
//			{
//				if ( adapter.isSelected( i ) )
//				{
//					test.deleteFile( adapter.getItem( i ).FILENAME );
//				}
//			}
//
//			overlay.removeAllViews();
//		} );
//
//		final Button btCancel = inflatedView.findViewById(R.id.bt_cancel);
//		btCancel.setOnClickListener( v -> overlay.removeAllViews() );
//	}

	@SuppressLint("ClickableViewAccessibility")
	void openManager( final MD10KVx parent, final MD10KVxTest test, List<FileDetails> values )
	{
		final Dialog dialog = new Dialog( activity );
		dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dialog.setContentView( R.layout.md10kvx_fgr_manager );
		dialog.setCanceledOnTouchOutside( false );
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().getAttributes().width = ViewGroup.LayoutParams.MATCH_PARENT;
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}

		((TextView) dialog.findViewById( R.id.tx_title )).setText( R.string.md_saved_tests );

		ImageButton btnClose = dialog.findViewById( R.id.btn_close_dlg );
		if ( btnClose != null )
		{
			btnClose.setOnClickListener( l -> dialog.dismiss() );
		}

		final ListView list = dialog.findViewById(R.id.listview);

		recorded = values;
		adapter = new RecordsBaseAdapter(parent, recorded);

		list.setAdapter(adapter);

		list.setOnItemClickListener( ( par, view, position, id ) ->
		{
			String fileName = adapter.getItem( position ).FILENAME;
			parent.loadResults( fileName );
			dialog.dismiss();
		} );

		final Button btDeleteSelected = dialog.findViewById(R.id.bt_delete_selected);
		btDeleteSelected.setVisibility(View.GONE);

		final Button btShowButtonDelete = dialog.findViewById(R.id.bt_confirm);
		btShowButtonDelete.setOnClickListener( v ->
		{
			try
			{
				if ( recorded == null || recorded.isEmpty() )
				{
					return;
				}
				adapter.enableSelection( true );
				btShowButtonDelete.setVisibility( View.GONE );
				btDeleteSelected.setVisibility( View.VISIBLE );
			}
			catch ( Exception ignored )
			{
			}
		} );

		btDeleteSelected.setOnClickListener( v ->
		{
			if ( !adapter.hasItemChecked() )
			{
				return;
			}

			int len = adapter.getCount();
			for ( int i = 0; i < len; i++ )
			{
				if ( adapter.isSelected( i ) )
				{
					test.deleteFile( adapter.getItem( i ).FILENAME );
				}
			}

			dialog.dismiss();
		} );

		
		final Button btCancel = dialog.findViewById(R.id.bt_cancel);
		btCancel.setOnClickListener( v -> dialog.dismiss() );

		dialog.show();
	}

	@SuppressLint("ClickableViewAccessibility")
	void warnAboutPause(  )
	{
		final FrameLayout overlay      = activity.findViewById( R.id.md10kvx_overlay );
		final View        inflatedView = View.inflate( activity, R.layout.md10kvx_fgr_msg, null );

		overlay.removeAllViews();
		overlay.addView( inflatedView );
		overlay.setVisibility( View.VISIBLE );

		//This is to prevent the ontouch propagate to others views
		RelativeLayout overlayBase = inflatedView.findViewById( R.id.overlay_base );
		overlayBase.requestDisallowInterceptTouchEvent( true );
		overlayBase.setOnTouchListener( ( v, event ) -> true );

		TextView title = inflatedView.findViewById( R.id.tx_title );
		title.setText( activity.getResources().getString( R.string.md_test_stopped ) );

		TextView message = inflatedView.findViewById( R.id.tx_message );
		message.setText( activity.getResources().getString( R.string.md_test_stopped_explained ) );

		Button btClose = inflatedView.findViewById( R.id.bt_confirm );
		btClose.setVisibility( View.GONE );

		Button btCancel = inflatedView.findViewById( R.id.bt_cancel );
		btCancel.setText( activity.getResources().getString( R.string.md_ok ) );
		btCancel.setOnClickListener( v -> overlay.removeAllViews() );
	}


	@SuppressLint("ClickableViewAccessibility")
	public void warnAboutLock()
	{
		final FrameLayout overlay      = activity.findViewById( R.id.md10kvx_overlay );
		final View        inflatedView = View.inflate( activity, R.layout.md10kvx_fgr_msg, null );

		overlay.removeAllViews();
		overlay.addView( inflatedView );
		overlay.setVisibility( View.VISIBLE );

		//This is to prevent the ontouch propagate to others views
		RelativeLayout overlayBase = inflatedView.findViewById( R.id.overlay_base );
		overlayBase.requestDisallowInterceptTouchEvent( true );
		overlayBase.setOnTouchListener( ( v, event ) -> true );

		TextView title = inflatedView.findViewById( R.id.tx_title );
		title.setText( activity.getResources().getString( R.string.md_remote_control_locked ) );

		TextView message = inflatedView.findViewById( R.id.tx_message );
		message.setText( activity.getResources().getString( R.string.md_remote_control_locked_explained ) );

		Button btClose = inflatedView.findViewById( R.id.bt_confirm );
		btClose.setVisibility( View.GONE );

		Button btCancel = inflatedView.findViewById( R.id.bt_cancel );
		btCancel.setText( activity.getResources().getString( R.string.md_ok ) );
		btCancel.setOnClickListener( v -> overlay.removeAllViews() );
	}

	@SuppressLint("ClickableViewAccessibility")
	void setupChangedDirectly( final MD10KVx parent )
	{
		final FrameLayout overlay      = activity.findViewById( R.id.md10kvx_overlay );
		final View        inflatedView = View.inflate( activity, R.layout.md10kvx_fgr_msg, null );

		overlay.removeAllViews();
		overlay.addView( inflatedView );
		overlay.setVisibility( View.VISIBLE );

		//This is to prevent the ontouch propagate to others views
		RelativeLayout overlayBase = inflatedView.findViewById( R.id.overlay_base );
		overlayBase.requestDisallowInterceptTouchEvent( true );
		overlayBase.setOnTouchListener( ( v, event ) -> true );

		TextView title = inflatedView.findViewById( R.id.tx_title );
		title.setText( activity.getResources().getString( R.string.md_configurations_changed ) );

		TextView message = inflatedView.findViewById( R.id.tx_message );
		message.setText( activity.getResources().getString( R.string.md_configurations_changed_explained ) );

		Button btConfirm = inflatedView.findViewById( R.id.bt_confirm );
		btConfirm.setText( activity.getResources().getString( R.string.md_sync_configurations ) );
		btConfirm.setOnClickListener( v ->
		{
			parent.addCommand( Command.MD10KVx.READ_SETUP() );
			overlay.removeAllViews();
		} );

		Button btCancel = inflatedView.findViewById( R.id.bt_cancel );
		btCancel.setVisibility( View.GONE );
	}


//	@SuppressLint({"ClickableViewAccessibility", "SetTextI18n"})
//	void createSet( final MD10KVx parent, boolean running )
//	{
//		final FrameLayout overlay      = activity.findViewById( R.id.md10kvx_overlay );
//		final View        inflatedView = View.inflate( activity, R.layout.md10kvx_fgr_setup, null );
//
////		DisplayMetrics metrics = new DisplayMetrics();
////		activity.getWindowManager().getDefaultDisplay().getMetrics(metrics);
////		android.widget.FrameLayout.LayoutParams params = (android.widget.FrameLayout.LayoutParams) overlay.getLayoutParams();
////		params.width =  metrics.widthPixels;
////		params.height = metrics.heightPixels;
////		params.leftMargin = 0;
////		params.topMargin = -50;
////		overlay.setLayoutParams(params);
//
//		overlay.setVisibility( View.VISIBLE );
//
//		//This is to prevent the ontouch propagate to others views
//		RelativeLayout overlayBase = inflatedView.findViewById( R.id.overlay_base );
//		overlayBase.requestDisallowInterceptTouchEvent( true );
//		overlayBase.setOnTouchListener( ( v, event ) -> true );
//
//		final TextView lbVoltage = inflatedView.findViewById( R.id.lb_voltage_set );
//
//		final String[] opFilter = new String[]
//		{
//			activity.getResources().getString( R.string.md_off ),
//			activity.getResources().getString( R.string.md_on )
//		};
//
//		final Spinner spFilter = inflatedView.findViewById(R.id.sp_filter);
//		ArrayAdapter<String> adFilter = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opFilter );
//		adFilter.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		spFilter.setAdapter(adFilter);
//
//		final String[] opMode = new String[]{"NORMAL","SVT:1","SVT:2"};
//		final Spinner spOpmode = inflatedView.findViewById(R.id.sp_opmode);
//		ArrayAdapter<String> adOpmode = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opMode );
//		adOpmode.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		spOpmode.setAdapter(adOpmode);
//
//		final String[] opLim = new String[]{"- - -", "10 M\u03A9", "100 M\u03A9", "1 G\u03A9", "10 G\u03A9"};
//		final Spinner spLim = inflatedView.findViewById(R.id.sp_lim);
//		ArrayAdapter<String> adLim = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opLim );
//		adLim.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		spLim.setAdapter(adLim);
//
//		final String[] opTimer = new String[]{"- - -","00:30", "01:00", "03:00", "10:00", "30:00"};
//		ArrayAdapter<String> adTimer = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opTimer );
//		adTimer.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		final Spinner spTimer = inflatedView.findViewById(R.id.sp_timer);
//		spTimer.setAdapter(adTimer);
//
//		final String[] opV1 = new String[]{"000","001","002","003","004","005","006","007","008","009","010"};
//		ArrayAdapter<String> adV1 = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opV1 );
//		adV1.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		final Spinner spV1 = inflatedView.findViewById(R.id.spinner1);
//		spV1.setAdapter(adV1);
//
//		final String[] opV2 = new String[]{"000", "025", "050", "075","100", "125", "150", "175","200", "225", "250", "275","300", "325", "350", "375","400", "425", "450", "475","500", "525", "550", "575","600", "625", "650", "675","700", "725", "750", "775","800", "825", "850", "875","900", "925", "950", "975"};
//		final ArrayAdapter<String> adV2 = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opV2 );
//		adV2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		final Spinner spV2 = inflatedView.findViewById(R.id.Spinner01);
//		spV2.setAdapter(adV2);
//
//		final String[] opV2B = new String[]{"500", "525", "550", "575","600", "625", "650", "675","700", "725", "750", "775","800", "825", "850", "875","900", "925", "950", "975"};
//		final ArrayAdapter<String> adV2B = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opV2B );
//		adV2B.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//
//		spOpmode.setOnItemSelectedListener( new OnItemSelectedListener()
//		{
//			public void onItemSelected( AdapterView<?> arg0, View arg1, int arg2, long arg3 )
//			{
//				if ( arg2 == 0 )
//				{
//					spLim.setEnabled( true );
//					spTimer.setEnabled( true );
//				}
//				else if ( arg2 == 1 )
//				{
//					spOpmode.setSelection( 1 );
//					spLim.setEnabled( false );
//					spLim.setSelection( 0 );
//					spTimer.setEnabled( false );
//					spTimer.setSelection( 0 );
//				}
//				else if ( arg2 == 2 )
//				{
//					spOpmode.setSelection( 2 );
//					spLim.setEnabled( false );
//					spLim.setSelection( 0 );
//					spTimer.setEnabled( false );
//					spTimer.setSelection( 0 );
//				}
//			}
//
//			public void onNothingSelected( AdapterView<?> arg0 )
//			{
//			}
//		} );
//
//		lbVoltage.setText( spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
//
//		if ( overlay.getChildCount() == 0 )
//		{
//			spFilter.setSelection( Command.MD10KVx.SEL_FILTER() );
//
//			int selVoltage = Command.MD10KVx.SEL_VOLTAGE();
//
//	        if(selVoltage>=10000){
//	        	spV1.setSelection(opV1.length-1);
//	        	spV2.setSelection(0);
//	        } else if(selVoltage>=1000){
//	        	String temp = selVoltage +"";
//	        	int kvx;
//	        	int vx;
//
//	        	int i = temp.length();
//	        	if(i>4){
//	        		 kvx = Integer.parseInt( temp.substring(0,2) );
//	        		 vx  = Integer.parseInt( temp.substring(2,5) );
//	        	} else {
//	        		kvx = Integer.parseInt( temp.substring(0,1) );
//	        		vx  = Integer.parseInt( temp.substring(1,4) );
//	        	}
//	        	spV1.setSelection(kvx);
//	        	spV2.setSelection(vx/25);
//	        } else {
//	        	int fullV = opV2.length;
//	        	int shortV = opV2B.length;
//	        	int diffV = fullV - shortV;
//
//	        	String temp = selVoltage +"";
//
//				int vx = Integer.parseInt( temp );
//	        	spV1.setSelection( 0 );
//	        	spV2.setAdapter(adV2B);
//	        	spV2.setSelection( vx/25-diffV );
//	        	//android.util.Log.e("ER", ""+ (vx/25-diffV));
//	        }
//
//	        int opmode = Command.MD10KVx.SEL_OPMODE();
//
//	        switch(opmode){
//	        case 0: // NORMAL
//	        	spOpmode.setSelection(0);
//	        	spLim.setSelection(0);
//	        	spLim.setEnabled(true);
//        		spTimer.setSelection(0);
//        		spTimer.setEnabled(true);
//	        	break;
//	        case 1: // SVT 1
//	        	spOpmode.setSelection(1);
//	        	spLim.setEnabled(false);
//	        	spLim.setSelection(0);
//	        	spTimer.setEnabled(false);
//        		spTimer.setSelection(0);
//	        	break;
//	        case 2: // SVT 2
//	        	spOpmode.setSelection(2);
//	        	spLim.setSelection(0);
//	        	spLim.setEnabled(false);
//        		spTimer.setSelection(0);
//        		spTimer.setEnabled(false);
//	        	break;
//	        case 3: // 00:30
//	        	spOpmode.setSelection(0);
//	        	spLim.setSelection(0);
//	        	spLim.setEnabled(true);
//        		spTimer.setSelection(1);
//        		spTimer.setEnabled(true);
//	        	break;
//	        case 4: // 01:00
//	        	spOpmode.setSelection(0);
//	        	spLim.setSelection(0);
//	        	spLim.setEnabled(true);
//        		spTimer.setSelection(2);
//        		spTimer.setEnabled(true);
//	        	break;
//	        case 5: // 03:00
//	        	spOpmode.setSelection(0);
//	        	spLim.setSelection(0);
//	        	spLim.setEnabled(true);
//        		spTimer.setSelection(3);
//        		spTimer.setEnabled(true);
//	        	break;
//	        case 6: // 10:00
//	        	spOpmode.setSelection(0);
//	        	spLim.setSelection(0);
//	        	spLim.setEnabled(true);
//        		spTimer.setSelection(4);
//        		spTimer.setEnabled(true);
//	        	break;
//	        case 7: // 30:00
//	        	spOpmode.setSelection(0);
//	        	spLim.setSelection(0);
//	        	spLim.setEnabled(true);
//        		spTimer.setSelection(5);
//        		spTimer.setEnabled(true);
//	        	break;
//	        }
//
//			int lim = Command.MD10KVx.SEL_LIM();
//			if ( lim > 0 )
//			{
//				spLim.setSelection( 0 );
//			}
//			spLim.setSelection( lim );
//
//			overlay.addView( inflatedView );
//		}
//		else // if ( overlay.getChildCount() == 0 )
//		{
//			overlay.removeAllViews();
//		}
//
//		spV1.setOnItemSelectedListener(new OnItemSelectedListener(){
//			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
//				parent.ignoreChanges();
//				if (arg2 == 0){// 0,NNN Volts
//					spV2.setEnabled(true);
//					if(spV2.getAdapter() == adV2){
//						spV2.setAdapter(adV2B);
//					}
//					lbVoltage.setText(spV2.getSelectedItem().toString() + " V" );
//				} else if(arg2 == 10){//10.000 Volts
//					spV2.setAdapter(adV2);
//					spV2.setSelection(0);
//					spV2.setEnabled(false);
//					lbVoltage.setText(spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
//				} else {
//					spV2.setEnabled(true);
//					if(spV2.getAdapter() == adV2B){
//						spV2.setAdapter(adV2);
//					}
//					lbVoltage.setText(spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
//				}
//
//			}
//			public void onNothingSelected(AdapterView<?> arg0) { }
//		});
//
//		spV2.setOnItemSelectedListener(new OnItemSelectedListener(){
//			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
//				parent.ignoreChanges();
//				if (spV1.getSelectedItem().toString().equals("0")){
//					lbVoltage.setText(spV2.getSelectedItem().toString() + " V" );
//				} else {
//					lbVoltage.setText(spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
//				}
//
//			}
//			public void onNothingSelected(AdapterView<?> arg0) { }
//		});
//
//		Button btSave = inflatedView.findViewById(R.id.bt_save);
//		btSave.setOnClickListener( v ->
//		{
//			int kv = spV1.getSelectedItemPosition()*1000;
//			int sv = Integer.parseInt( spV2.getSelectedItem().toString() );
//
//			int maxVoltage = Integer.parseInt( opV1[opV1.length-1] )*1000;
//			int voltage = kv + sv;
//
//			if(voltage>maxVoltage){
//				voltage = maxVoltage;
//			}
//
//			int param1 = voltage / 25;
//
//			int opmode = spOpmode.getSelectedItemPosition();
//			int lim    = spLim.getSelectedItemPosition();
//			int timer  = spTimer.getSelectedItemPosition();
//			int param2;
//
//			if ( opmode == 0 && timer > 0 )
//			{
//				param2 = timer + 2;
//			}
//			else
//			{
//				param2 = opmode;
//			}
//
//			if( spFilter.getSelectedItemPosition()!=Command.MD10KVx.SEL_FILTER() ){
//				parent.addCommand( Command.MD10KVx.FILTER() );
//			}
//
//			parent.addCommand( Command.MD10KVx.WRITE_SETUP(param1, param2, lim) );
//			overlay.removeAllViews();
//			parent.enableCommandButtons(false);
//
//			messageBox(activity.getResources().getString(R.string.md_updating), MD10KVxUI.COLOR_YELLOW, true);
//		} );
//
//		Button btCancel = inflatedView.findViewById(R.id.bt_cancel);
//		btCancel.setOnClickListener( v ->
//		{
//			if ( overlay.getChildCount() == 0 )
//			{
//				overlay.addView( inflatedView );
//			}
//			else
//			{
//				overlay.removeAllViews();
//			}
//		} );
//
//		if ( running )
//		{
//			spOpmode.setEnabled( false );
//			spLim.setEnabled( false );
//			spTimer.setEnabled( false );
//
//			spOpmode.setOnItemSelectedListener( null );
//
//			int opmode = Command.MD10KVx.SEL_OPMODE();
//			if ( opmode == 1 || opmode == 2 )
//			{
//				spV1.setEnabled( false );
//				spV2.setEnabled( false );
//				spV1.setOnItemSelectedListener( null );
//			}
//		}
//	}

//	@SuppressLint({"ClickableViewAccessibility", "SetTextI18n"})
//	void createSet( final MD10KVx parent, boolean running )
//	{
//		final FrameLayout overlay      = activity.findViewById( R.id.md10kvx_overlay );
//		final View        inflatedView = View.inflate( activity, R.layout.md10kvx_fgr_setup, null );
//
//		overlay.setVisibility( View.VISIBLE );
//
//		RelativeLayout overlayBase = inflatedView.findViewById( R.id.overlay_base ); //This is to prevent the ontouch propagate to others views
//		overlayBase.requestDisallowInterceptTouchEvent( true );
//		overlayBase.setOnTouchListener( ( v, event ) -> true );
//
//		final TextView lbVoltage = inflatedView.findViewById( R.id.lb_voltage_set );
//		final Switch swFilter = inflatedView.findViewById( R.id.swt_filter );
//
//		final String[] opMode = new String[]{"NORMAL","SVT:1","SVT:2"};
//		final Spinner spOpmode = inflatedView.findViewById(R.id.sp_opmode);
//		ArrayAdapter<String> adOpmode = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opMode );
//		adOpmode.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		spOpmode.setAdapter(adOpmode);
//
//		final String[] opLim = new String[]{"- - -", "10 M\u03A9", "100 M\u03A9", "1 G\u03A9", "10 G\u03A9"};
//		final Spinner spLim = inflatedView.findViewById(R.id.sp_lim);
//		ArrayAdapter<String> adLim = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opLim );
//		adLim.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		spLim.setAdapter(adLim);
//
//		final String[] opTimer = new String[]{"- - -","00:30", "01:00", "03:00", "10:00", "30:00"};
//		ArrayAdapter<String> adTimer = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opTimer );
//		adTimer.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		final Spinner spTimer = inflatedView.findViewById(R.id.sp_timer);
//		spTimer.setAdapter(adTimer);
//
//		final String[] opV1 = new String[]{"000","001","002","003","004","005","006","007","008","009","010"};
//		ArrayAdapter<String> adV1 = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opV1 );
//		adV1.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		final Spinner spV1 = inflatedView.findViewById(R.id.spinner1);
//		spV1.setAdapter(adV1);
//
//		final String[] opV2 = new String[]{"000", "025", "050", "075","100", "125", "150", "175","200", "225", "250", "275","300", "325", "350", "375","400", "425", "450", "475","500", "525", "550", "575","600", "625", "650", "675","700", "725", "750", "775","800", "825", "850", "875","900", "925", "950", "975"};
//		final ArrayAdapter<String> adV2 = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opV2 );
//		adV2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//		final Spinner spV2 = inflatedView.findViewById(R.id.Spinner01);
//		spV2.setAdapter(adV2);
//
//		final String[] opV2B = new String[]{"500", "525", "550", "575","600", "625", "650", "675","700", "725", "750", "775","800", "825", "850", "875","900", "925", "950", "975"};
//		final ArrayAdapter<String> adV2B = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opV2B );
//		adV2B.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
//
//		spOpmode.setOnItemSelectedListener( new OnItemSelectedListener()
//		{
//			public void onItemSelected( AdapterView<?> arg0, View arg1, int arg2, long arg3 )
//			{
//				if ( arg2 == 0 )
//				{
//					spLim.setEnabled( true );
//					spTimer.setEnabled( true );
//				}
//				else if ( arg2 == 1 )
//				{
//					spOpmode.setSelection( 1 );
//					spLim.setEnabled( false );
//					spLim.setSelection( 0 );
//					spTimer.setEnabled( false );
//					spTimer.setSelection( 0 );
//				}
//				else if ( arg2 == 2 )
//				{
//					spOpmode.setSelection( 2 );
//					spLim.setEnabled( false );
//					spLim.setSelection( 0 );
//					spTimer.setEnabled( false );
//					spTimer.setSelection( 0 );
//				}
//			}
//
//			public void onNothingSelected( AdapterView<?> arg0 )
//			{
//			}
//		} );
//
//		lbVoltage.setText( spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
//
//		if ( overlay.getChildCount() == 0 )
//		{
//			swFilter.setChecked( Command.MD10KVx.SEL_FILTER() == 1 );
//
//			int selVoltage = Command.MD10KVx.SEL_VOLTAGE();
//
//			if(selVoltage>=10000){
//				spV1.setSelection(opV1.length-1);
//				spV2.setSelection(0);
//			} else if(selVoltage>=1000){
//				String temp = selVoltage +"";
//				int kvx;
//				int vx;
//
//				int i = temp.length();
//				if(i>4){
//					kvx = Integer.parseInt( temp.substring(0,2) );
//					vx  = Integer.parseInt( temp.substring(2,5) );
//				} else {
//					kvx = Integer.parseInt( temp.substring(0,1) );
//					vx  = Integer.parseInt( temp.substring(1,4) );
//				}
//				spV1.setSelection(kvx);
//				spV2.setSelection(vx/25);
//			}
//			else
//			{
//				int fullV = opV2.length;
//				int shortV = opV2B.length;
//				int diffV = fullV - shortV;
//
//				String temp = selVoltage + "";
//
//				int vx = Integer.parseInt( temp );
//				spV1.setSelection( 0 );
//				spV2.setAdapter( adV2B );
//				spV2.setSelection( vx / 25 - diffV );
//			}
//
//			int opmode = Command.MD10KVx.SEL_OPMODE();
//
//			switch(opmode){
//				case 0: // NORMAL
//					spOpmode.setSelection(0);
//					spLim.setSelection(0);
//					spLim.setEnabled(true);
//					spTimer.setSelection(0);
//					spTimer.setEnabled(true);
//					break;
//				case 1: // SVT 1
//					spOpmode.setSelection(1);
//					spLim.setEnabled(false);
//					spLim.setSelection(0);
//					spTimer.setEnabled(false);
//					spTimer.setSelection(0);
//					break;
//				case 2: // SVT 2
//					spOpmode.setSelection(2);
//					spLim.setSelection(0);
//					spLim.setEnabled(false);
//					spTimer.setSelection(0);
//					spTimer.setEnabled(false);
//					break;
//				case 3: // 00:30
//					spOpmode.setSelection(0);
//					spLim.setSelection(0);
//					spLim.setEnabled(true);
//					spTimer.setSelection(1);
//					spTimer.setEnabled(true);
//					break;
//				case 4: // 01:00
//					spOpmode.setSelection(0);
//					spLim.setSelection(0);
//					spLim.setEnabled(true);
//					spTimer.setSelection(2);
//					spTimer.setEnabled(true);
//					break;
//				case 5: // 03:00
//					spOpmode.setSelection(0);
//					spLim.setSelection(0);
//					spLim.setEnabled(true);
//					spTimer.setSelection(3);
//					spTimer.setEnabled(true);
//					break;
//				case 6: // 10:00
//					spOpmode.setSelection(0);
//					spLim.setSelection(0);
//					spLim.setEnabled(true);
//					spTimer.setSelection(4);
//					spTimer.setEnabled(true);
//					break;
//				case 7: // 30:00
//					spOpmode.setSelection(0);
//					spLim.setSelection(0);
//					spLim.setEnabled(true);
//					spTimer.setSelection(5);
//					spTimer.setEnabled(true);
//					break;
//			}
//
//			int lim = Command.MD10KVx.SEL_LIM();
//			if ( lim > 0 )
//			{
//				spLim.setSelection( 0 );
//			}
//			spLim.setSelection( lim );
//
//			overlay.addView( inflatedView );
//		}
//		else // if ( overlay.getChildCount() == 0 )
//		{
//			overlay.removeAllViews();
//		}
//
//		spV1.setOnItemSelectedListener(new OnItemSelectedListener(){
//			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
//				parent.ignoreChanges();
//				if (arg2 == 0){// 0,NNN Volts
//					spV2.setEnabled(true);
//					if(spV2.getAdapter() == adV2){
//						spV2.setAdapter(adV2B);
//					}
//					lbVoltage.setText(spV2.getSelectedItem().toString() + " V" );
//				} else if(arg2 == 10){//10.000 Volts
//					spV2.setAdapter(adV2);
//					spV2.setSelection(0);
//					spV2.setEnabled(false);
//					lbVoltage.setText(spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
//				} else {
//					spV2.setEnabled(true);
//					if(spV2.getAdapter() == adV2B){
//						spV2.setAdapter(adV2);
//					}
//					lbVoltage.setText(spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
//				}
//
//			}
//			public void onNothingSelected(AdapterView<?> arg0) { }
//		});
//
//		spV2.setOnItemSelectedListener(new OnItemSelectedListener(){
//			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
//				parent.ignoreChanges();
//				if (spV1.getSelectedItem().toString().equals("0")){
//					lbVoltage.setText(spV2.getSelectedItem().toString() + " V" );
//				} else {
//					lbVoltage.setText(spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
//				}
//
//			}
//			public void onNothingSelected(AdapterView<?> arg0) { }
//		});
//
//		Button btSave = inflatedView.findViewById(R.id.bt_save);
//		btSave.setOnClickListener( v ->
//		{
//			int kv = spV1.getSelectedItemPosition()*1000;
//			int sv = Integer.parseInt( spV2.getSelectedItem().toString() );
//
//			int maxVoltage = Integer.parseInt( opV1[opV1.length-1] )*1000;
//			int voltage = kv + sv;
//
//			if(voltage>maxVoltage){
//				voltage = maxVoltage;
//			}
//
//			int param1 = voltage / 25;
//
//			int opmode = spOpmode.getSelectedItemPosition();
//			int lim    = spLim.getSelectedItemPosition();
//			int timer  = spTimer.getSelectedItemPosition();
//			int param2;
//
//			if ( opmode == 0 && timer > 0 )
//			{
//				param2 = timer + 2;
//			}
//			else
//			{
//				param2 = opmode;
//			}
//
//			int filterOpt = swFilter.isChecked() ? 1 : 0;
//
//			if ( filterOpt != Command.MD10KVx.SEL_FILTER() )
//			{
//				parent.addCommand( Command.MD10KVx.FILTER() );
//			}
//
//			parent.addCommand( Command.MD10KVx.WRITE_SETUP(param1, param2, lim) );
//			overlay.removeAllViews();
//			parent.enableCommandButtons(false);
//
//			messageBox(activity.getResources().getString(R.string.md_updating), MD10KVxUI.COLOR_YELLOW, true);
//		} );
//
//		Button btCancel = inflatedView.findViewById(R.id.bt_cancel);
//		btCancel.setOnClickListener( v ->
//		{
//			if ( overlay.getChildCount() == 0 )
//			{
//				overlay.addView( inflatedView );
//			}
//			else
//			{
//				overlay.removeAllViews();
//			}
//		} );
//
//		if ( running )
//		{
//			spOpmode.setEnabled( false );
//			spLim.setEnabled( false );
//			spTimer.setEnabled( false );
//
//			spOpmode.setOnItemSelectedListener( null );
//
//			int opmode = Command.MD10KVx.SEL_OPMODE();
//			if ( opmode == 1 || opmode == 2 )
//			{
//				spV1.setEnabled( false );
//				spV2.setEnabled( false );
//				spV1.setOnItemSelectedListener( null );
//			}
//		}
//	}

	@SuppressLint({"ClickableViewAccessibility", "SetTextI18n"})
	void createSet( final MD10KVx parent, boolean running )
	{
		final Dialog dialog = new Dialog(activity );
		dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dialog.setContentView( R.layout.md10kvx_fgr_setup );
		dialog.setCanceledOnTouchOutside( false );
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().getAttributes().width = ViewGroup.LayoutParams.MATCH_PARENT;
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}

		ImageButton btnClose = dialog.findViewById( R.id.btn_close_dlg );
		if ( btnClose != null )
		{
			btnClose.setOnClickListener( l -> dialog.dismiss() );
		}

		final TextView lbVoltage = dialog.findViewById( R.id.lb_voltage_set );
		final Switch swFilter = dialog.findViewById( R.id.swt_filter );

		final String[] opMode = new String[]{"NORMAL","SVT:1","SVT:2"};
		final Spinner spOpmode = dialog.findViewById(R.id.sp_opmode);
		ArrayAdapter<String> adOpmode = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opMode );
		adOpmode.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spOpmode.setAdapter(adOpmode);

		final String[] opLim = new String[]{"- - -", "10 M\u03A9", "100 M\u03A9", "1 G\u03A9", "10 G\u03A9"};
		final Spinner spLim = dialog.findViewById(R.id.sp_lim);
		ArrayAdapter<String> adLim = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opLim );
		adLim.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		spLim.setAdapter(adLim);

		final String[] opTimer = new String[]{"- - -","00:30", "01:00", "03:00", "10:00", "30:00"};
		ArrayAdapter<String> adTimer = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opTimer );
		adTimer.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		final Spinner spTimer = dialog.findViewById(R.id.sp_timer);
		spTimer.setAdapter(adTimer);

		final String[] opV1 = new String[]{"000","001","002","003","004","005","006","007","008","009","010"};
		ArrayAdapter<String> adV1 = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opV1 );
		adV1.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		final Spinner spV1 = dialog.findViewById(R.id.spinner1);
		spV1.setAdapter(adV1);

		final String[] opV2 = new String[]{"000", "025", "050", "075","100", "125", "150", "175","200", "225", "250", "275","300", "325", "350", "375","400", "425", "450", "475","500", "525", "550", "575","600", "625", "650", "675","700", "725", "750", "775","800", "825", "850", "875","900", "925", "950", "975"};
		final ArrayAdapter<String> adV2 = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opV2 );
		adV2.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);
		final Spinner spV2 = dialog.findViewById(R.id.Spinner01);
		spV2.setAdapter(adV2);

		final String[] opV2B = new String[]{"500", "525", "550", "575","600", "625", "650", "675","700", "725", "750", "775","800", "825", "850", "875","900", "925", "950", "975"};
		final ArrayAdapter<String> adV2B = new ArrayAdapter<>( parent, android.R.layout.simple_spinner_item, opV2B );
		adV2B.setDropDownViewResource(android.R.layout.simple_spinner_dropdown_item);

		spOpmode.setOnItemSelectedListener( new OnItemSelectedListener()
		{
			public void onItemSelected( AdapterView<?> arg0, View arg1, int arg2, long arg3 )
			{
				if ( arg2 == 0 )
				{
					spLim.setEnabled( true );
					spTimer.setEnabled( true );
				}
				else if ( arg2 == 1 )
				{
					spOpmode.setSelection( 1 );
					spLim.setEnabled( false );
					spLim.setSelection( 0 );
					spTimer.setEnabled( false );
					spTimer.setSelection( 0 );
				}
				else if ( arg2 == 2 )
				{
					spOpmode.setSelection( 2 );
					spLim.setEnabled( false );
					spLim.setSelection( 0 );
					spTimer.setEnabled( false );
					spTimer.setSelection( 0 );
				}
			}

			public void onNothingSelected( AdapterView<?> arg0 )
			{
			}
		} );

		lbVoltage.setText( spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );

			swFilter.setChecked( Command.MD10KVx.SEL_FILTER() == 1 );

			int selVoltage = Command.MD10KVx.SEL_VOLTAGE();

			if(selVoltage>=10000){
				spV1.setSelection(opV1.length-1);
				spV2.setSelection(0);
			} else if(selVoltage>=1000){
				String temp = selVoltage +"";
				int kvx;
				int vx;

				int i = temp.length();
				if(i>4){
					kvx = Integer.parseInt( temp.substring(0,2) );
					vx  = Integer.parseInt( temp.substring(2,5) );
				} else {
					kvx = Integer.parseInt( temp.substring(0,1) );
					vx  = Integer.parseInt( temp.substring(1,4) );
				}
				spV1.setSelection(kvx);
				spV2.setSelection(vx/25);
			}
			else
			{
				int fullV = opV2.length;
				int shortV = opV2B.length;
				int diffV = fullV - shortV;

				String temp = selVoltage + "";

				int vx = Integer.parseInt( temp );
				spV1.setSelection( 0 );
				spV2.setAdapter( adV2B );
				spV2.setSelection( vx / 25 - diffV );
			}

			int opmode = Command.MD10KVx.SEL_OPMODE();

			switch(opmode){
				case 0: // NORMAL
					spOpmode.setSelection(0);
					spLim.setSelection(0);
					spLim.setEnabled(true);
					spTimer.setSelection(0);
					spTimer.setEnabled(true);
					break;
				case 1: // SVT 1
					spOpmode.setSelection(1);
					spLim.setEnabled(false);
					spLim.setSelection(0);
					spTimer.setEnabled(false);
					spTimer.setSelection(0);
					break;
				case 2: // SVT 2
					spOpmode.setSelection(2);
					spLim.setSelection(0);
					spLim.setEnabled(false);
					spTimer.setSelection(0);
					spTimer.setEnabled(false);
					break;
				case 3: // 00:30
					spOpmode.setSelection(0);
					spLim.setSelection(0);
					spLim.setEnabled(true);
					spTimer.setSelection(1);
					spTimer.setEnabled(true);
					break;
				case 4: // 01:00
					spOpmode.setSelection(0);
					spLim.setSelection(0);
					spLim.setEnabled(true);
					spTimer.setSelection(2);
					spTimer.setEnabled(true);
					break;
				case 5: // 03:00
					spOpmode.setSelection(0);
					spLim.setSelection(0);
					spLim.setEnabled(true);
					spTimer.setSelection(3);
					spTimer.setEnabled(true);
					break;
				case 6: // 10:00
					spOpmode.setSelection(0);
					spLim.setSelection(0);
					spLim.setEnabled(true);
					spTimer.setSelection(4);
					spTimer.setEnabled(true);
					break;
				case 7: // 30:00
					spOpmode.setSelection(0);
					spLim.setSelection(0);
					spLim.setEnabled(true);
					spTimer.setSelection(5);
					spTimer.setEnabled(true);
					break;
			}

			int lim = Command.MD10KVx.SEL_LIM();
			if ( lim > 0 )
			{
				spLim.setSelection( 0 );
			}
			spLim.setSelection( lim );


		spV1.setOnItemSelectedListener(new OnItemSelectedListener(){
			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				parent.ignoreChanges();
				if (arg2 == 0){// 0,NNN Volts
					spV2.setEnabled(true);
					if(spV2.getAdapter() == adV2){
						spV2.setAdapter(adV2B);
					}
					lbVoltage.setText(spV2.getSelectedItem().toString() + " V" );
				} else if(arg2 == 10){//10.000 Volts
					spV2.setAdapter(adV2);
					spV2.setSelection(0);
					spV2.setEnabled(false);
					lbVoltage.setText(spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
				} else {
					spV2.setEnabled(true);
					if(spV2.getAdapter() == adV2B){
						spV2.setAdapter(adV2);
					}
					lbVoltage.setText(spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
				}

			}
			public void onNothingSelected(AdapterView<?> arg0) { }
		});

		spV2.setOnItemSelectedListener(new OnItemSelectedListener(){
			public void onItemSelected(AdapterView<?> arg0, View arg1, int arg2, long arg3) {
				parent.ignoreChanges();
				if (spV1.getSelectedItem().toString().equals("0")){
					lbVoltage.setText(spV2.getSelectedItem().toString() + " V" );
				} else {
					lbVoltage.setText(spV1.getSelectedItem().toString() + "," + spV2.getSelectedItem().toString() + " V" );
				}

			}
			public void onNothingSelected(AdapterView<?> arg0) { }
		});

		Button btSave = dialog.findViewById(R.id.bt_save);
		btSave.setOnClickListener( v ->
		{
			int kv = spV1.getSelectedItemPosition()*1000;
			int sv = Integer.parseInt( spV2.getSelectedItem().toString() );

			int maxVoltage = Integer.parseInt( opV1[opV1.length-1] )*1000;
			int voltage = kv + sv;

			if(voltage>maxVoltage){
				voltage = maxVoltage;
			}

			int param1 = voltage / 25;

			int opmodeS = spOpmode.getSelectedItemPosition();
			int limS    = spLim.getSelectedItemPosition();
			int timer  = spTimer.getSelectedItemPosition();
			int param2;

			if ( opmodeS == 0 && timer > 0 )
			{
				param2 = timer + 2;
			}
			else
			{
				param2 = opmodeS;
			}

			int filterOpt = swFilter.isChecked() ? 1 : 0;

			if ( filterOpt != Command.MD10KVx.SEL_FILTER() )
			{
				parent.addCommand( Command.MD10KVx.FILTER() );
			}

			parent.addCommand( Command.MD10KVx.WRITE_SETUP(param1, param2, limS) );
			parent.enableCommandButtons(false);

			messageBox(activity.getResources().getString(R.string.md_updating), MD10KVxUI.COLOR_YELLOW, true);
			dialog.dismiss();
		} );

		Button btCancel = dialog.findViewById(R.id.bt_cancel);
		btCancel.setOnClickListener( v ->
		{
			dialog.dismiss();
		} );

		if ( running )
		{
			spOpmode.setEnabled( false );
			spLim.setEnabled( false );
			spTimer.setEnabled( false );

			spOpmode.setOnItemSelectedListener( null );

			int opmodeR = Command.MD10KVx.SEL_OPMODE();
			if ( opmodeR == 1 || opmodeR == 2 )
			{
				spV1.setEnabled( false );
				spV2.setEnabled( false );
				spV1.setOnItemSelectedListener( null );
			}
		}

		dialog.show();
	}

	public void changeButtonImage( int buttonId, int image, boolean enable )
	{
		((ImageButton) activity.findViewById( buttonId )).setImageResource( image );
		enableButton( activity.findViewById( buttonId ), enable );
	}
	
	void enableSaveButton( boolean enabled, MD10KVxTest test ){
		enableButton( activity.findViewById(R.id.button_save), enabled);
		
		if(test.getTestDate().equals("")){
			enableButton( activity.findViewById(R.id.bt_export), false);
		}
		else{
			enableButton( activity.findViewById(R.id.bt_export), !enabled);
		}			
	}

//	public void enableExportButton(boolean enabled){
//		//enableButton((ImageButton) activity.findViewById(R.id.bt_export), enabled);
//	}

	@SuppressWarnings("SameParameterValue")
	void enableGpsButton( boolean enabled )
	{
		enableButton( activity.findViewById( R.id.bt_gps ), enabled );
	}

	void enableManagerButton( boolean enabled )
	{
		enableButton( activity.findViewById( R.id.button_manager ), enabled );
	}

	void enableRecordButton( boolean enabled )
	{
		enableButton( activity.findViewById( R.id.bt_record ), enabled );
	}

	void enablePictureButton( boolean enabled )
	{
		enableButton( activity.findViewById( R.id.bt_picture ), enabled );
	}

//	public void enableSecondaryButtons(boolean enabled){
//		//((ImageButton) activity.findViewById(R.id.button_save)).setEnabled(enabled);
//		enableButton((ImageButton) activity.findViewById(R.id.button_save), enabled);
//	}

	private void enableButton( ImageButton btn, boolean enable )
	{
		int alpha = enable ? 255 : 51;
		btn.setEnabled( enable );
		btn.getDrawable().setAlpha( alpha );
	}


	Display display()
	{
		return display;
	}

	/* CLASS DISPLAY ############################### */

	public class Display
	{
		private Activity activity;
		private TextView display_text_number;
		private TextView display_time_elapsed;
		private TextView display_resistance;
		private TextView display_voltage;
		private TextView display_setup_voltage;
		private TextView display_current;
		private TextView display_lim;
		private TextView display_timer;
		private TextView display_svt;
		private TextView display_capacitance_result;
		private TextView display_pi_result;
		private TextView display_svt_result;
		private TextView display_dai_result;
		private TextView display_model;
				
		Display( Activity _activity )
		{
			this.activity              = _activity;
			display_text_number        = activity.findViewById(R.id.lb_test_number);
			display_time_elapsed       = activity.findViewById(R.id.lb_time_elapsed);
			display_resistance         = activity.findViewById(R.id.lb_resistance);
			display_voltage            = activity.findViewById(R.id.lb_voltage);
			display_current            = activity.findViewById(R.id.lb_current);
			display_setup_voltage      = activity.findViewById(R.id.lb_defined_voltage);
			display_lim                = activity.findViewById(R.id.lb_lim);
			display_timer              = activity.findViewById(R.id.lb_timer);
			display_svt  			   = activity.findViewById(R.id.lb_svt);
			display_capacitance_result = activity.findViewById(R.id.lb_result_capacitance);
			display_pi_result          = activity.findViewById(R.id.lb_result_pi);
			display_svt_result         = activity.findViewById(R.id.lb_result_svt);
			display_dai_result         = activity.findViewById(R.id.lb_result_dai);
			display_model              = activity.findViewById(R.id.lb_model);
						
			activity.findViewById(R.id.container_resistance).getHeight();
		}

		public void clear(){
			display_text_number.setText("- - -");
			display_time_elapsed.setText("- - -");
			display_resistance.setText("- - -");
			display_voltage.setText("- - -");
			display_current.setText("- - -");
			display_capacitance_result.setText("- - -");
			display_pi_result.setText("- - -");
			display_svt_result.setText("- - -");
			display_dai_result.setText("- - -");
		}

		void clearAll(){
			clear();
			display_setup_voltage.setText("- - -");
			display_lim.setText("- - -");
			display_timer.setText("- - -");
			display_svt.setText("- - -");
		}
		
		public void model(String model){
			display_model.setText(model);
		}
		
		public String model(){
			return display_model.getText()+"";
		}
		
		public void testNumber(String number){
			display_text_number.setText(number);
		}
		
		public String testNumber(){
			return display_text_number.getText()+"";
		}
		
		void elapsedTime( String time ){
			display_time_elapsed.setText(time);
		}
		
		public void current(String current){
			display_current.setText(current);
		}
		
		public void resistance(String resistance){
			display_resistance.setText(resistance);
		}
		
		public void voltage(String voltage){
			display_voltage.setText(voltage);
		}
		
		void capacitance( String capacitance ){
			display_capacitance_result.setText(capacitance);
		}
		
		String capacitance(){
			return display_capacitance_result.getText()+"";
		}
		
		public void pi(String pi){
			display_pi_result.setText(pi);
		}
		
		public String pi(){
			return display_pi_result.getText()+"";
		}
		
		public void dai(String dai){
			display_dai_result.setText(dai);
		}
		
		public String dai(){
			return display_dai_result.getText()+"";
		}
		
		public void svt(String svt){
			display_svt_result.setText(svt);
		}
		
		public String svt(){
			return display_svt_result.getText()+"";
		}
		
		void setupLim( String lim ){
			display_lim.setText(lim);
		}
		
		void setupVoltage( String voltage ){
			display_setup_voltage.setText(voltage);
		}
		
		void setupTimer( String timer ){
			display_timer.setText(timer);
		}
		
		void setupSvt( String svt ){
			display_svt.setText(svt);
		}
		
//		public void gps(String svt){
//			display_gps.setVisibility(View.VISIBLE);
//			display_gps.setText(svt);
//		}		
	}
	
}
