package com.megabras.bluelogg.tm25r;

import java.io.File;
import java.util.ArrayList;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.ImageView;
import android.widget.TextView;

import com.megabras.bluelogg.R;
import com.megabras.modbus.TM25R.Measurement;

public class ListDetails extends BaseAdapter {
	
	private LayoutInflater mInflater;
	private ArrayList<Measurement> itens;

	
    public ListDetails(Context context, ArrayList<Measurement> itens) {
        this.itens = itens;
        mInflater = LayoutInflater.from(context);
    }
	 

    public int getCount() {
        return itens.size();
    }
	 
    /**
     * Retorna o item de acordo com a posicao dele na tela.
     *
     * @param position
     * @return
     */
    public Measurement getItem(int position) {
        return itens.get(position);
    }
	 
    /**
     * Sem implementacao
     *
     * @param position
     * @return
     */
    public long getItemId(int position) {
        return position;
    }

    public View getView(int position, View view, ViewGroup parent) {
        Measurement item = itens.get(position);
        view = mInflater.inflate(R.layout.list_object_readings, null);

        ((TextView) view.findViewById(R.id.txt_test_num)).setText(item.getTestNumber());
        ((TextView) view.findViewById(R.id.txt_test_date)).setText(item.getDate());
        ((TextView) view.findViewById(R.id.txt_r)).setText(item.getResistance());
        ((TextView) view.findViewById(R.id.txt_rc)).setText(item.getResistanceCompensated());
        ((TextView) view.findViewById(R.id.txt_c)).setText(item.getCapacitance());
        ((TextView) view.findViewById(R.id.txt_l)).setText(item.getInductance());
        
        if(item.getAudio().exists())
        	view.findViewById(R.id.img_audio).setVisibility(View.VISIBLE);

        return view;
    }
	
	
	
	
}
