package com.megabras.bluelogg.tm25r;

import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.megabras.bluelogg.R;
import com.megabras.modbus.TM25R.FormatData;
import com.megabras.modbus.TM25R.Measurement;
import com.megabras.modbus.TM25R.Protocol;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.List;

public class TableBaseAdapter extends BaseAdapter
{
    private LayoutInflater
            inflater;

    private List<Measurement>
            values;

    private final int
            headerLayout = R.layout.tm25r_table_header;//,
            //lineLayout   = R.layout.table_item;

    private SimpleDateFormat
            dateFormat = new SimpleDateFormat("dd/MM/yyyy HH:mm");

    private Context
            context;

    public TableBaseAdapter(Context context)
    {
        this.context = context;
        values       = new ArrayList<>();
        inflater     = LayoutInflater.from(context);
    }

    static class ViewHolder
    {
        TextView
                tv_text_number,
                tv_date,
                tv_r,
                tv_rc,
                tv_c,
                tv_l;
    }

    public long getItemId(int position)
    {
        return 0;
    }

    public int getCount()
    {
        return values.size();
    }

    public Measurement getItem(int position)
    {
        return values.get(position);
    }

    public void add(Measurement m){
        values.add( m );
    }

    public void remove(int position)
    {
        values.remove(position);
    }


    public void clear(){
        values.clear();
    }

    public void repaint()
    {
        notifyDataSetChanged();
    }

    private TextView getTV(int id, View v)
    {
        return ( (TextView)v.findViewById(id) );
    }

    public View getView(int position, View vi, ViewGroup parent)
    {
        if ( vi == null )
        {
            ViewHolder h        = new ViewHolder();
            vi                  = inflater.inflate(headerLayout, parent, false);
            h.tv_text_number    = getTV(R.id.tv_number , vi);
            h.tv_date           = getTV(R.id.tv_date   , vi);
            h.tv_r              = getTV(R.id.tv_r      , vi);
            h.tv_rc             = getTV(R.id.tv_rc     , vi);
            h.tv_c              = getTV(R.id.tv_c      , vi);
            h.tv_l              = getTV(R.id.tv_l , vi);
            vi.setTag(h);
        }

        ViewHolder h = (ViewHolder) vi.getTag();
        h.tv_text_number.setText( values.get(position).getTestNumber() );
        h.tv_date.setText( values.get(position).getDate());
        h.tv_r.setText( values.get(position).getResistance() );
        h.tv_rc.setText( values.get(position).getResistanceCompensated() );
        h.tv_c.setText( values.get(position).getCapacitance() );
        h.tv_l.setText(values.get(position).getInductance() );



        return vi;
    }

}

